(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* -------------------------------------------------------------------- *)
(* Package to calculate generic amplitude for given process and to write SARAH code from that                           *)
(* Necessary to load FeynArts and FormCalc!!                           *)
(* -------------------------------------------------------------------- *)


(* ---------------------- Replacements  ------------------- *)



(* subLoopIntegrals={D0i[int_,p1_,p2_,p3_,p4_,p5_,p6_,a_,b_,c_,d_] ->int[a,b,c,d], C0i[int_,p1_,p2_,p3_,a_,b_,c_]->int[p1,p2,p3,a,b,c],B0i[int_,p1_,a_,b_]->int[p1,a,b]}; *)


subLoopIntegrals={D0i[dd00,p1_,p2_,p3_,p4_,p5_,p6_,a_,b_,c_,d_] -> dd00[a,b,c,d], D0i[int_,p1_,p2_,p3_,p4_,p5_,p6_,a_,b_,c_,d_] ->int[a,b,c,d],C0i[cc00,p1_,p2_,p3_,a_,b_,c_]->C003m[a,b,c], C0i[cc2,p1_,p2_,p3_,a_,b_,c_]->vertexC12aux[a,b,c],C0i[cc1,p1_,p2_,p3_,a_,b_,c_]->vertexC11aux[a,b,c]-vertexC12aux[a,b,c],B0i[int_,p1_,a_,b_]->int[0,a,b], C0i[cc0,p1_,p2_,p3_,a_,b_,c_]->C03m[a,b,c]};
subLoopIntegralsCombinations={bb0[0,b_,a_]+c_ C03m[a_,b_,c_]->B0C0check[a,b,c],bb0[0,a_,b_]+c_ C03m[a_,b_,c_]->B0C0check[a,b,c],d__ bb0[0,b_,a_]+d__ c_ C03m[a_,b_,c_]->d B0C0check[a,b,c],d__ bb0[0,a_,b_]+d__ c_ C03m[a_,b_,c_]->d B0C0check[a,b,c],c1_ bb0[0,a_,b_]+(d__+c1_ c_) C03m[a_,b_,c_]->c1 B0C0check[a,b,c]+d C03m[a,b,c],c1_ bb0[0,b_,a_]+(d__+c1_ c_) C03m[a_,b_,c_]->c1 B0C0check[a,b,c]+d C03m[a,b,c], C03m[a_,b_,c_]+d_ dd0[___,d_,___]->C0D0check[a,b,c,d], f_ C03m[a_,b_,c_]+f_ d_ dd0[___,d_,___]->f C0D0check[a,b,c,d], mF1*mF2*dd0[a__]->MMD0[mF1,mF2,a]};
UseOneShell=True;

subfinal={mS1^2->mS12,mS2^2->mS22,mV1^2->mV12,mV2^2->mV22,mF1^2->mF12,mF2^2->mF22,MFin^2->MFin2, -1.a__ + a__->0};

StartingDirectory= Directory[];
$preSARAHdir=SetDirectory[DirectoryName[System`Private`FindFile[$Input]]];

SetOptions[Paint,ColumnsXRows->1,SheetHeader->False,Numbering->False];



(* Function to tranlsate 'Process' in correct FeynArts Syntax and extracting some information which is used later *)
InitProcess:=Block[{i,temp},
FermionOrderBoxes=FermionOrderExternal;
Switch[ConsideredProcess,
"4Fermion",
Init4FermionProcess;,
"2Fermion1Scalar",
Init2Fermion1ScalarProcess;,
"2Fermion1Vector",
Init2Fermion1VectorProcess;,
_,
Print["Process not yet supported"];
];


(* IMPORTANT: The notebook assumes the conventions/syntax of FeynArts-3.5 and FormCalc 7.; to be compatible with newer version, some things have to be substituted *)
(* It might be necessary to make a more detailed check also for the FeynArts version ! *)

If[$FormCalc<8.0, 
FC8sub={};
Subexpr[] ={}; ,
FC8sub={NonCommutative->NonCommutativeMultiply, ChiralityProjector[-1]->FormCalc`Private`ga[7],ChiralityProjector[1]->FormCalc`Private`ga[6]};
];



temp=TeXNames;

TeXNames={};
For[i=1,i<=Length[temp],
TeXNames=Join[TeXNames,{ToString[temp[[i,1]]]->temp[[i,2]]}];
i++;];
];
Init2Fermion1ScalarProcess:=Init2Fermion1BosonProcess["SCALAR"];
Init2Fermion1VectorProcess:=Init2Fermion1BosonProcess["VECTOR"];

Init2Fermion1BosonProcess[type_]:=Block[{i,j},
Init2FermionTopologies21;

subMasslessBoson={};
subMasslessBosonsSums={};
subMasslessBosonsArgs={};
If[type==="SCALAR",
ProcessFA={F[3,{1}],-F[2,{1}]}->S[3];
Pex1=F[3,{1,_}];
Pex2=-F[2,{1}]; 
Pex3=S[3];,
 ProcessFA={F[3,{1}],-F[2,{1}]}->V[3];
Pex1=F[3,{1,_}];
Pex2=-F[2,{1}]; 
Pex3=V[3];
];

If[MemberQ[NeglectMasses,3]==True,
(*
subMasslessBoson={
C0i[cc0,p1_,p2_,p3_,a_,b_,c_] ->C0m[a,b,c],
C0i[cc1,p1_,p2_,p3_,a_,b_,c_] ->C1m[a,b,c],
C0i[cc11,p1_,p2_,p3_,a_,b_,c_] ->C11m[a,b,c],
C0i[cc12,p1_,p2_,p3_,a_,b_,c_] ->C12m[a,b,c],
C0i[cc22,p1_,p2_,p3_,a_,b_,c_] ->C22m[a,b,c],
C0i[cc2,p1_,p2_,p3_,a_,b_,c_] ->C2m[a,b,c],
C0i[cc00,p1_,p2_,p3_,a_,b_,c_] ->C00m[a,b,c]
};*)

subMasslessBoson={
C0i[cc0,p1_,p2_,p3_,a_,b_,c_] ->C0m,
C0i[cc1,p1_,p2_,p3_,a_,b_,c_] ->C1m,
C0i[cc11,p1_,p2_,p3_,a_,b_,c_] ->C11m,
C0i[cc12,p1_,p2_,p3_,a_,b_,c_] ->C12m,
C0i[cc22,p1_,p2_,p3_,a_,b_,c_] ->C22m,
C0i[cc2,p1_,p2_,p3_,a_,b_,c_] ->C2m,
C0i[cc00,p1_,p2_,p3_,a_,b_,c_] ->C00m
};
subMasslessBosonsSums={
C2m+C12m+C22m->C2C12C22,C1m+C12m+C11m->C1C12C11,C0m+C1m+C2m->C0C1C2,2 C12m+2 C11m-C2m->C12C11C2,2 C12m-C1m+2 C22m->C12C22C1,C1m+C2m->C1C2,C12m+C22m->C12C22,C2m+C12m->C2C12};
subMasslessBosonsArgs={C0m->C0g[ARG1,ARG2,ARG3],C00m->C00g[ARG1,ARG2,ARG3],C1m->C1g[ARG1,ARG2,ARG3],C2m->C2g[ARG1,ARG2,ARG3],C11m->C11g[ARG1,ARG2,ARG3],C12m->C12g[ARG1,ARG2,ARG3],C22m->C22g[ARG1,ARG2,ARG3],C2C12C22->C2C12C22[ARG1,ARG2,ARG3],C1C12C11->C1C12C11[ARG1,ARG2,ARG3],C0C1C2->C0C1C2[ARG1,ARG2,ARG3],C12C11C2->C12C11C2[ARG1,ARG2,ARG3],C12C22C1->C12C22C1[ARG1,ARG2,ARG3],C1C2->C1C2[ARG1,ARG2,ARG3],C2C12->C2C12[ARG1,ARG2,ARG3],C12C22->C12C22[ARG1,ARG2,ARG3]};
];

subExternalMasses = {MassEx1^2->MassEx12,MassEx2^2->MassEx22,MassEx3^2->MassEx32,
Mf[3,1]->MassEx1,Mf[2,1]->MassEx2,MW->MassEx3,
Mf[3,1]^2->MassEx1^2,Mf[2,1]^2->MassEx2^2,MW^2->MassEx3^2};

InitializeModel["SM"];
TheLabel[F[3,{1,_}]]=ComposedChar["f","1"];
TheLabel[F[2,{1}]]=ComposedChar["f","2"];
If[type==="SCALAR",
TheLabel[S[3]]="s";
TheLabel[S[2]]="s";,
TheLabel[V[2]]="v";
TheLabel[V[3]]="v";
];

subZero={};
subZeroBoxes={};

For[i=1,i<=4,
If[MemberQ[NeglectMasses,i],
subZero=Join[subZero,{ToExpression["MassEx"<>ToString[i]]->0,ToExpression["MassEx"<>ToString[i]<>"2"]->0}];
subZeroBoxes=Join[subZeroBoxes,{ToExpression["MassEx"<>ToString[i]]->0,ToExpression["MassEx"<>ToString[i]<>"2"]->0}];
];
i++;
];

massorder=ToExpression["MassEx"<>ToString[#]]&/@{1,2,3,4};

spinors={Spinor[k[FermionOrderBoxes[[1]]],massorder[[FermionOrderBoxes[[1]]]],-1],
Spinor[k[FermionOrderBoxes[[2]]],massorder[[FermionOrderBoxes[[2]]]],1]
};

PS`sign=-Signature[FermionOrderBoxes];

TriangleOperators = Table[{AllOperators[[i,1]],CreateChain2F[spinors,AllOperators[[i,2]]]},{i,1,Length[AllOperators]}];

];

Init4FermionProcess:=Block[{i,j},
subLoopIntegrals={D0i[dd00,p1_,p2_,p3_,p4_,p5_,p6_,a_,b_,c_,d_] -> dd00[a,b,c,d], D0i[int_,p1_,p2_,p3_,p4_,p5_,p6_,a_,b_,c_,d_] ->int[a,b,c,d],C0i[cc00,p1_,p2_,p3_,a_,b_,c_]->C003m[a,b,c], C0i[cc2,p1_,p2_,p3_,a_,b_,c_]->vertexC12aux[a,b,c],C0i[cc1,p1_,p2_,p3_,a_,b_,c_]->vertexC11aux[a,b,c]-vertexC12aux[a,b,c],B0i[int_,p1_,a_,b_]->int[0,a,b], C0i[cc0,p1_,p2_,p3_,a_,b_,c_]->C03m[a,b,c]};


Init4FermionTopologies22;

	(* ProcessFA=F[3,{1}]->{F[2,{1}],-F[2,{2}],F[2,{3}]}; *)
	ProcessFA={F[3,{1}],-F[2,{1}]}->{-F[2,{2}],F[2,{3}]};
	Pex1=F[3,{1,_}]; 
	Pex2=-F[2,{1}];
	Pex3=F[2,{2}]; 
	Pex4=-F[2,{3}];

subExternalMasses = {MassEx1^2->MassEx12,MassEx2^2->MassEx22,MassEx3^2->MassEx32,MassEx4^2->MassEx42,
Mf[3,1]->MassEx1,Mf[2,1]->MassEx2,Mf[2,2]->MassEx3,Mf[2,3]->MassEx4,
Mf[3,1]^2->MassEx1^2,Mf[2,1]^2->MassEx2^2,Mf[2,2]^2->MassEx3^2,Mf[2,3]^2->MassEx4^2};

InitializeModel["SM"];
TheLabel[F[3,{1,___}]]=ComposedChar["f","1"];
TheLabel[F[2,{1}]]=ComposedChar["f","2"];
TheLabel[F[2,{2}]]=ComposedChar["f","3"];
TheLabel[F[2,{3}]]=ComposedChar["f","4"];



subZero={};
subZeroBoxes={};


For[i=1,i<=4,
If[MemberQ[NeglectMasses,i],
subZero=Join[subZero,{ToExpression["MassEx"<>ToString[i]]->0,ToExpression["MassEx"<>ToString[i]<>"2"]->0}];
subZeroBoxes=Join[subZeroBoxes,{ToExpression["MassEx"<>ToString[i]]->0,ToExpression["MassEx"<>ToString[i]<>"2"]->0}];
];
i++;
];

massorder=ToExpression["MassEx"<>ToString[#]]&/@{1,2,3,4};

spinors={Spinor[k[FermionOrderBoxes[[1]]],massorder[[FermionOrderBoxes[[1]]]],-1],
Spinor[k[FermionOrderBoxes[[2]]],massorder[[FermionOrderBoxes[[2]]]],1],
Spinor[k[FermionOrderBoxes[[3]]],massorder[[FermionOrderBoxes[[3]]]],1],
Spinor[k[FermionOrderBoxes[[4]]],massorder[[FermionOrderBoxes[[4]]]],-1]
};

PS`sign=-Signature[FermionOrderBoxes];


If[Head[BoxOperators]=!=List || BoxOperators==={},
AddBoxes=False;,
AddBoxes=True;
(* BoxOperatorsFull = Table[{BoxOperatorsShort[[i,1]],CreateChain[spinors,BoxOperatorsShort[[i,2]]]},{i,1,Length[BoxOperatorsShort]}]; *)
BoxOperators = Table[{BoxOperators[[i,1]],CreateChain[spinors,BoxOperators[[i,2]]]},{i,1,Length[BoxOperators]}];
];

If[Head[ScalarTreeOperators]=!=List || ScalarTreeOperators==={},
AddScalarsTree=False;,AddScalarsTree=True;
ScalarTreeOperators = Table[{ScalarTreeOperators[[i,1]],CreateChain[spinors,ScalarTreeOperators[[i,2]]]},{i,1,Length[ScalarTreeOperators]}];
];

If[Head[VectorTreeOperators]=!=List || VectorTreeOperators==={},
AddVectorsTree=False;,AddVectorsTree=True;
VectorTreeOperators = Table[{VectorTreeOperators[[i,1]],CreateChain[spinors,VectorTreeOperators[[i,2]]]},{i,1,Length[VectorTreeOperators]}];
];

If[Head[ScalarPenguinOperators]=!=List || ScalarPenguinOperators==={},
AddScalars=False;,
AddScalars=True;
ScalarPenguinOperators = Table[{ScalarPenguinOperators[[i,1]],CreateChain[spinors,ScalarPenguinOperators[[i,2]]]},{i,1,Length[ScalarPenguinOperators]}];
ScalarWaveOperators=ScalarPenguinOperators;
];

If[Head[VectorPenguinOperators]=!=List || VectorPenguinOperators==={},
AddVectors=False;,
AddVectors=True;
VectorPenguinOperators = Table[{VectorPenguinOperators[[i,1]],CreateChain[spinors,VectorPenguinOperators[[i,2]]]},{i,1,Length[VectorPenguinOperators]}];
VectorWaveOperators=VectorPenguinOperators;
];


];

CreateChain[spinors_,op_]:=Block[{i,j,res},Return[(DiracChain[spinors[[1]],op[[1]],spinors[[2]]]*DiracChain[spinors[[3]],op[[2]],spinors[[4]]]//.DiracChain[a___,Op[b___],c___]->DiracChain[a,b,c])];
];
CreateChain2F[spinors_,op_]:=Block[{i,j,res,ecs},
Return[ (op/(op/.Op[c__] d__->Op[c])*DiracChain[spinors[[1]],(op/.Op[c__] d__->Op[c]),spinors[[2]]]//.DiracChain[a___,Op[b___],c___]->DiracChain[a,b,c])];
];

Init2FermionTopologies21:=Block[{},
subLoopIntegrals={C0i[int_,p1_,p2_,p3_,a_,b_,c_]->int[p1,p2,p3,a,b,c],B0i[int_,p1_,a_,b_]->int[p1,a,b],
cc00[0,0,0,a_,b_,c_]->C003m[a,b,c],cc2[0,0,0,a_,b_,c_]->vertexC12aux[a,b,c], cc1[0,0,0,a_,b_,c_]->vertexC11aux[a,b,c]-vertexC12aux[a,b,c],cc0[0,0,0,a_,b_,c_]->C03m[a,b,c]};


(* -------------------- Triangle ------------------------ *)
triangle=CreateTopologies[1,2->1][[1]];

(* -------------------- Wave ------------------------ *)
waves=CreateTopologies[1,2->1,ExcludeTopologies->{Tadpoles}];
waves=DiagramDelete[waves,{1..8}];

(* ------------------- Tree -------------------*)
tree=CreateTopologies[0,2->1];
];




Init4FermionTopologies31:=Block[{},
(* ---------------------- Boxes  ------------------- *)

boxes=CreateTopologies[1,1->3, ExcludeTopologies->{SelfEnergies,WFCorrections,Triangles,Tadpoles}];
boxes=DiagramDelete[boxes,{1..6,10,11,12}]; 

(*----------------------Penguins& waves-------------------*)penguins=CreateTopologies[1,1->3,ExcludeTopologies->{SelfEnergies,WFCorrections,Boxes,Tadpoles}];
 penguins=DiagramDelete[penguins,{1,2,4,7.. 24}]; 


waves=CreateTopologies[1,1->3,ExcludeTopologies->{Boxes,Triangles,Tadpoles}];
waves=DiagramDelete[waves,{1.. 30}];
waves=DiagramDelete[waves,{3,4}];

(*----------------------Tree-------------------*)
tree=CreateTopologies[0,1->3];
tree=DiagramDelete[tree,{1}];
];

Init4FermionTopologies22:=Block[{},
(* ---------------------- Boxes  ------------------- *)

boxes=CreateTopologies[1,2->2, ExcludeTopologies->{SelfEnergies,WFCorrections,Triangles,Tadpoles}];
boxes=DiagramDelete[boxes,{1..6,10,11,12}]; 

(*----------------------Penguins& waves-------------------*)penguins=CreateTopologies[1,2->2,ExcludeTopologies->{SelfEnergies,WFCorrections,Boxes,Tadpoles}];
(* penguins=DiagramDelete[penguins,{1,2,4,7.. 24}]; *)
penguins=TopologyList@@(Join[DiagramExtract[penguins,{3,5,6}],DiagramExtract[penguins,{1,2,4}]]);

(*
waves=CreateTopologies[1,2->2,ExcludeTopologies->{Boxes,Triangles,Tadpoles}];
waves=DiagramDelete[waves,{1.. 30}];
waves=DiagramDelete[waves,{3,4}];
*)
waves=CreateTopologies[1,2->2,ExcludeTopologies->{Boxes,Triangles,Tadpoles}];
waves=DiagramDelete[waves,{1.. 24}];
waves=DiagramDelete[waves,{3,6}];
waves=TopologyList@@(Join[DiagramExtract[waves,{5,6,9,10,11,12}],DiagramExtract[waves,{1,2,3,4,7,8}]]);

(*----------------------Tree-------------------*)
tree=CreateTopologies[0,2->2];
tree=DiagramDelete[tree,{1}];
];

(* We have to replace the vertices introduced by FeynArts by the convention of SARAH/SPheno *)
(* We assume that the external particle X couples to the vertex coupXL,coupXR (for left/right) *)

(*
subVertBoxes1={
G[s___*1][0][a___,Pex1,b__][NonCommutative[d___,ChiralityProjector[-1]]]->coup1L,
G[s___*1][0][a___, Pex1,b__][NonCommutative[d___,ChiralityProjector[1]]]->coup1R,
G[s___*1][0][a___,Pex2,b__][NonCommutative[d___,ChiralityProjector[-1]]]->coup2L,
G[s___*1][0][a___,Pex2,b__][NonCommutative[d___,ChiralityProjector[1]]]->coup2R,
G[s___*1][0][a___, Pex3,b__][NonCommutative[d___,ChiralityProjector[-1]]]->coup4L,
G[s___*1][0][a___,Pex3,b__][NonCommutative[d___,ChiralityProjector[1]]]->coup4R,
G[s___*1][0][a___,Pex4,b__][NonCommutative[d___,ChiralityProjector[-1]]]->coup3L,
G[s___*1][0][a___,Pex4,b__][NonCommutative[d___,ChiralityProjector[1]]]->coup3R};

subVertBoxes2={
G[s___*1][0][a___,Pex1,b__][NonCommutative[d___,ChiralityProjector[-1]]]->coup1L,
G[s___*1][0][a___, Pex1,b__][NonCommutative[d___,ChiralityProjector[1]]]->coup1R,
G[s___*1][0][a___,Pex2,b__][NonCommutative[d___,ChiralityProjector[-1]]]->coup2L,
G[s___*1][0][a___,Pex2,b__][NonCommutative[d___,ChiralityProjector[1]]]->coup2R,
G[s___*1][0][a___, Pex4,b__][NonCommutative[d___,ChiralityProjector[-1]]]->coup4L,
G[s___*1][0][a___,Pex4,b__][NonCommutative[d___,ChiralityProjector[1]]]->coup4R,
G[s___*1][0][a___,Pex3,b__][NonCommutative[d___,ChiralityProjector[-1]]]->coup3L,
G[s___*1][0][a___,Pex3,b__][NonCommutative[d___,ChiralityProjector[1]]]->coup3R};

subVertBoxes3={
G[s___*1][0][a___,Pex1,b__][NonCommutative[d___,ChiralityProjector[-1]]]->coup1L,
G[s___*1][0][a___, Pex1,b__][NonCommutative[d___,ChiralityProjector[1]]]->coup1R,
G[s___*1][0][a___,Pex3,b__][NonCommutative[d___,ChiralityProjector[-1]]]->coup2L,
G[s___*1][0][a___,Pex3,b__][NonCommutative[d___,ChiralityProjector[1]]]->coup2R,
G[s___*1][0][a___, Pex2,b__][NonCommutative[d___,ChiralityProjector[-1]]]->coup4L,
G[s___*1][0][a___,Pex2,b__][NonCommutative[d___,ChiralityProjector[1]]]->coup4R,
G[s___*1][0][a___,Pex4,b__][NonCommutative[d___,ChiralityProjector[-1]]]->coup3L,
G[s___*1][0][a___,Pex4,b__][NonCommutative[d___,ChiralityProjector[1]]]->coup3R};
*)

subVertBoxes={
G[s___*1][0][a___,Pex1,b__][NonCommutative[ChiralityProjector[-1]]]->coup1L,
G[s___*1][0][a___,Pex1,b__][NonCommutative[ChiralityProjector[1]]]->coup1R,
G[s___*1][0][a_,Pex1,b_][NonCommutative[d_,ChiralityProjector[-1]]]->coup1L,
G[s___*1][0][a_,Pex1,b_][NonCommutative[d_,ChiralityProjector[1]]]->coup1R,
G[s___*1][0][Pex1,b__][NonCommutative[d_,ChiralityProjector[-1]]]->-coup1R,
G[s___*1][0][Pex1,b__][NonCommutative[d_,ChiralityProjector[1]]]->-coup1L,

G[s___*1][0][a___,Pex2,b__][NonCommutative[ChiralityProjector[-1]]]->coup2L,
G[s___*1][0][a___,Pex2,b__][NonCommutative[ChiralityProjector[1]]]->coup2R,
G[s___*1][0][Pex2,b__][NonCommutative[d_,ChiralityProjector[-1]]]->coup2L,
G[s___*1][0][Pex2,b__][NonCommutative[d_,ChiralityProjector[1]]]->coup2R,
G[s___*1][0][a_,Pex2,b_][NonCommutative[d_,ChiralityProjector[-1]]]->-coup2R,
G[s___*1][0][a_,Pex2,b_][NonCommutative[d_,ChiralityProjector[1]]]->-coup2L,


G[s___*1][0][a___, Pex3,b__][NonCommutative[ChiralityProjector[-1]]]->coup3L,
G[s___*1][0][a___,Pex3,b__][NonCommutative[ChiralityProjector[1]]]->coup3R,
G[s___*1][0][a_, Pex3,b_][NonCommutative[d_,ChiralityProjector[-1]]]->coup3L,
G[s___*1][0][a_,Pex3,b_][NonCommutative[d_,ChiralityProjector[1]]]->coup3R,
G[s___*1][0][Pex3,b__][NonCommutative[d_,ChiralityProjector[-1]]]->-coup3R,
G[s___*1][0][Pex3,b__][NonCommutative[d_,ChiralityProjector[1]]]->-coup3L,

G[s___*1][0][a___,Pex4,b__][NonCommutative[ChiralityProjector[-1]]]->coup4L,
G[s___*1][0][a___,Pex4,b__][NonCommutative[ChiralityProjector[1]]]->coup4R,
G[s___*1][0][Pex4,b__][NonCommutative[d_,ChiralityProjector[-1]]]->coup4L,
G[s___*1][0][Pex4,b__][NonCommutative[d_,ChiralityProjector[1]]]->coup4R,
G[s___*1][0][a_,Pex4,b__][NonCommutative[d_,ChiralityProjector[-1]]]->-coup4R,
G[s___*1][0][a_,Pex4,b__][NonCommutative[d_,ChiralityProjector[1]]]->-coup4L
};

subVertBoxes1=subVertBoxes/.{coup3L->coup4L,coup3R->coup4R,coup4L->coup3L,coup4R->coup3R};
subVertBoxes2=subVertBoxes;
subVertBoxes3=subVertBoxes /.{coup2L->coup4L,coup2R->coup4R,coup4L->coup2L,coup4R->coup2R};

(*
subVertBoxes1={
G[s___*1][0][a___,Pex1,b__][NonCommutative[ChiralityProjector[-1]]]->coup1L,
G[s___*1][0][a___,Pex1,b__][NonCommutative[ChiralityProjector[1]]]->coup1R,
G[s___*1][0][a_,Pex1,b_][NonCommutative[d_,ChiralityProjector[-1]]]->coup1L,
G[s___*1][0][a_,Pex1,b_][NonCommutative[d_,ChiralityProjector[1]]]->coup1R,
G[s___*1][0][Pex1,b__][NonCommutative[d_,ChiralityProjector[-1]]]->-coup1R,
G[s___*1][0][Pex1,b__][NonCommutative[d_,ChiralityProjector[1]]]->-coup1L,

G[s___*1][0][a___,Pex2,b__][NonCommutative[ChiralityProjector[-1]]]->coup2L,
G[s___*1][0][a___,Pex2,b__][NonCommutative[ChiralityProjector[1]]]->coup2R,
G[s___*1][0][Pex2,b__][NonCommutative[d_,ChiralityProjector[-1]]]->coup2L,
G[s___*1][0][Pex2,b__][NonCommutative[d_,ChiralityProjector[1]]]->coup2R,
G[s___*1][0][a_,Pex2,b_][NonCommutative[d_,ChiralityProjector[-1]]]->-coup2R,
G[s___*1][0][a_,Pex2,b_][NonCommutative[d_,ChiralityProjector[1]]]->-coup2L,


G[s___*1][0][a___, Pex3,b__][NonCommutative[ChiralityProjector[-1]]]->coup4L,
G[s___*1][0][a___,Pex3,b__][NonCommutative[ChiralityProjector[1]]]->coup4R,
G[s___*1][0][a_, Pex3,b_][NonCommutative[d_,ChiralityProjector[-1]]]->coup4L,
G[s___*1][0][a_,Pex3,b_][NonCommutative[d_,ChiralityProjector[1]]]->coup4R,
G[s___*1][0][Pex3,b__][NonCommutative[d_,ChiralityProjector[-1]]]->-coup4R,
G[s___*1][0][Pex3,b__][NonCommutative[d_,ChiralityProjector[1]]]->-coup4L,

G[s___*1][0][a___,Pex4,b__][NonCommutative[ChiralityProjector[-1]]]->coup3L,
G[s___*1][0][a___,Pex4,b__][NonCommutative[ChiralityProjector[1]]]->coup3R,
G[s___*1][0][Pex4,b__][NonCommutative[d_,ChiralityProjector[-1]]]->coup3L,
G[s___*1][0][Pex4,b__][NonCommutative[d_,ChiralityProjector[1]]]->coup3R,
G[s___*1][0][a_,Pex4,b__][NonCommutative[d_,ChiralityProjector[-1]]]->-coup3R,
G[s___*1][0][a_,Pex4,b__][NonCommutative[d_,ChiralityProjector[1]]]->-coup3L
};


subVertBoxes2={
G[s___*1][0][a___,Pex1,b__][NonCommutative[ChiralityProjector[-1]]]->coup1L,
G[s___*1][0][a___,Pex1,b__][NonCommutative[ChiralityProjector[1]]]->coup1R,
G[s___*1][0][a_,Pex1,b_][NonCommutative[d_,ChiralityProjector[-1]]]->coup1L,
G[s___*1][0][a_,Pex1,b_][NonCommutative[d_,ChiralityProjector[1]]]->coup1R,
G[s___*1][0][Pex1,b__][NonCommutative[d_,ChiralityProjector[-1]]]->-coup1R,
G[s___*1][0][Pex1,b__][NonCommutative[d_,ChiralityProjector[1]]]->-coup1L,

G[s___*1][0][a___,Pex2,b__][NonCommutative[ChiralityProjector[-1]]]->coup2L,
G[s___*1][0][a___,Pex2,b__][NonCommutative[ChiralityProjector[1]]]->coup2R,
G[s___*1][0][Pex2,b__][NonCommutative[d_,ChiralityProjector[-1]]]->coup2L,
G[s___*1][0][Pex2,b__][NonCommutative[d_,ChiralityProjector[1]]]->coup2R,
G[s___*1][0][a_,Pex2,b_][NonCommutative[d_,ChiralityProjector[-1]]]->-coup2R,
G[s___*1][0][a_,Pex2,b_][NonCommutative[d_,ChiralityProjector[1]]]->-coup2L,


G[s___*1][0][a___, Pex3,b___][NonCommutative[ChiralityProjector[-1]]]->coup3L,
G[s___*1][0][a___,Pex3,b___][NonCommutative[ChiralityProjector[1]]]->coup3R,
G[s___*1][0][a_, Pex3,b_][NonCommutative[d_,ChiralityProjector[-1]]]->coup3L,
G[s___*1][0][a_,Pex3,b_][NonCommutative[d_,ChiralityProjector[1]]]->coup3R,
G[s___*1][0][Pex3,b__][NonCommutative[d_,ChiralityProjector[-1]]]->-coup3R,
G[s___*1][0][Pex3,b__][NonCommutative[d_,ChiralityProjector[1]]]->-coup3L,

G[s___*1][0][a___,Pex4,b__][NonCommutative[ChiralityProjector[-1]]]->coup4L,
G[s___*1][0][a___,Pex4,b__][NonCommutative[ChiralityProjector[1]]]->coup4R,
G[s___*1][0][Pex4,b__][NonCommutative[d_,ChiralityProjector[-1]]]->coup4L,
G[s___*1][0][Pex4,b__][NonCommutative[d_,ChiralityProjector[1]]]->coup4R,
G[s___*1][0][a_,Pex4,b__][NonCommutative[d_,ChiralityProjector[-1]]]->-coup4R,
G[s___*1][0][a_,Pex4,b__][NonCommutative[d_,ChiralityProjector[1]]]->-coup4L
};

subVertBoxes3={
G[s___*1][0][a___,Pex1,b__][NonCommutative[ChiralityProjector[-1]]]->coup1L,
G[s___*1][0][a___,Pex1,b__][NonCommutative[ChiralityProjector[1]]]->coup1R,
G[s___*1][0][a_,Pex1,b_][NonCommutative[d_,ChiralityProjector[-1]]]->coup1L,
G[s___*1][0][a_,Pex1,b_][NonCommutative[d_,ChiralityProjector[1]]]->coup1R,
G[s___*1][0][Pex1,b__][NonCommutative[d_,ChiralityProjector[-1]]]->-coup1R,
G[s___*1][0][Pex1,b__][NonCommutative[d_,ChiralityProjector[1]]]->-coup1L,

G[s___*1][0][a___,Pex2,b__][NonCommutative[ChiralityProjector[-1]]]->coup4L,
G[s___*1][0][a___,Pex2,b__][NonCommutative[ChiralityProjector[1]]]->coup4R,
G[s___*1][0][Pex2,b__][NonCommutative[d_,ChiralityProjector[-1]]]->coup4L,
G[s___*1][0][Pex2,b__][NonCommutative[d_,ChiralityProjector[1]]]->coup4R,
G[s___*1][0][a_,Pex2,b_][NonCommutative[d_,ChiralityProjector[-1]]]->-coup4R,
G[s___*1][0][a_,Pex2,b_][NonCommutative[d_,ChiralityProjector[1]]]->-coup4L,


G[s___*1][0][a___, Pex3,b__][NonCommutative[ChiralityProjector[-1]]]->coup3L,
G[s___*1][0][a___,Pex3,b__][NonCommutative[ChiralityProjector[1]]]->coup3R,
G[s___*1][0][a_, Pex3,b_][NonCommutative[d_,ChiralityProjector[-1]]]->coup3L,
G[s___*1][0][a_,Pex3,b_][NonCommutative[d_,ChiralityProjector[1]]]->coup3R,
G[s___*1][0][Pex3,b__][NonCommutative[d_,ChiralityProjector[-1]]]->-coup3R,
G[s___*1][0][Pex3,b__][NonCommutative[d_,ChiralityProjector[1]]]->-coup3L,

G[s___*1][0][a___,Pex4,b__][NonCommutative[ChiralityProjector[-1]]]->coup2L,
G[s___*1][0][a___,Pex4,b__][NonCommutative[ChiralityProjector[1]]]->coup2R,
G[s___*1][0][Pex4,b__][NonCommutative[d_,ChiralityProjector[-1]]]->coup2L,
G[s___*1][0][Pex4,b__][NonCommutative[d_,ChiralityProjector[1]]]->coup2R,
G[s___*1][0][a_,Pex4,b__][NonCommutative[d_,ChiralityProjector[-1]]]->-coup2R,
G[s___*1][0][a_,Pex4,b__][NonCommutative[d_,ChiralityProjector[1]]]->-coup2L
};
*)




CalcAnalyticBoxes[top_,nr_,process_,operators_,fermionorder_,neglect_]:=Block[{i,j,k,len,all,result={},internalfields,sub},
ins=InsertFields[top,process,InsertionLevel->{Generic}];
len=Length[ins[[1,2]]];

Switch[nr,
1,subBoxes=subVertBoxes1;,
2,subBoxes=subVertBoxes2;,
3,subBoxes=subVertBoxes3;
];

If[FC8sub=!={},
subBoxes=subBoxes //.FC8sub;
subBoxes=subBoxes  /. NonCommutativeMultiply[b_]->b;
];
(* If[FC8sub=!={},subBoxes=Join[subBoxes,subBoxes /. NonCommutativeMultiply[a_,b_]->b(*/. NonCommutativeMultiply[a_,b_]->b*) ];]; *)

 For[i=1,i<=len, 
Print["Diagram Nr.", i];
dia=DiagramDelete[ins,Delete[Table[j,{j,1,len}],i]];
Paint[dia];
ClearProcess[];
 amp=CalcFeynAmp[CreateFeynAmp[dia] //. subExternalMasses,FermionChains->Chiral,FermionOrder->fermionorder,Dimension->PS`DimensionsLoop]; 
(* amp=CalcFeynAmp[CreateFeynAmp[dia] /. subExternalMasses,FermionChains->Chiral,FermionOrder->fermionorder]; *)
amp = amp //.Subexpr[] /.Abbr[]/.GenericList[] //.FC8sub//. subExternalMasses //. neglect ;
internalfields=List@@dia[[1,2,1]];
sub=GenerateSubstitutionsBoxes[{Field[5],Field[6],Field[7],Field[8]} /. internalfields];
amp=amp//.sub   //. FormCalc`S23->0 //. FormCalc`T12->0   //. FeynArts`T->0 //. FeynArts`S->0 //. FeynArts`U->0 //. FormCalc`S12->0;

result=Join[result,{{{Field[5],Field[6],Field[7],Field[8]} /. internalfields,Table[{operators[[j,1]],FullSimplify[Expand[PS`sign 16*Pi^2*Coefficient[Expand[amp[[1]]],Mat[operators[[j,2]]/. neglect]]]//. subLoopIntegrals //. subBoxes //.sub //.subfinal]/. subLoopIntegralsCombinations},{j,1,Length[operators]}]}}];
i++;];
Return[result];
];

GenerateSubstitutionsBoxes[{p1_,p2_,p3_,p4_}]:=Block[{temp={}},
Switch[p1,
F,
	temp=Join[temp,{Mass[F[Index[Generic,5]],Loop]->mF1,Mass[F[Index[Generic,8]],Loop]->mF2}];
	If[p2===V,
	temp=Join[temp,{Mass[V[Index[Generic,6]],Loop]->mV1}];,
	temp=Join[temp,{Mass[S[Index[Generic,6]],Loop]->mS1}];
	];
	If[p3===V,
	temp=Join[temp,{Mass[V[Index[Generic,7]],Loop]->mV2}];,
	temp=Join[temp,{Mass[S[Index[Generic,7]],Loop]->mS2}];
	];,
S,
	temp=Join[temp,{Mass[S[Index[Generic,5]],Loop]->mS1,Mass[F[Index[Generic,6]],Loop]->mF1,Mass[F[Index[Generic,7]],Loop]->mF2}];
	If[p4===V,
	temp=Join[temp,{Mass[V[Index[Generic,8]],Loop]->mV2}];,
	temp=Join[temp,{Mass[S[Index[Generic,8]],Loop]->mS2}];
	];,
V,
	temp=Join[temp,{Mass[V[Index[Generic,5]],Loop]->mV1,Mass[F[Index[Generic,6]],Loop]->mF1,Mass[F[Index[Generic,7]],Loop]->mF2}];
	If[p4===V,
	temp=Join[temp,{Mass[V[Index[Generic,8]],Loop]->mV2}];,
	temp=Join[temp,{Mass[S[Index[Generic,8]],Loop]->mS2}];
	];
];
Return[temp];
];


CalculateAllBoxes:=Block[{i,temp1,temp2,temp3,temp4},
(* Running all three topologies. Be careful: definition of the topology have to agree in SARAH and FeynArts! => compare GenerateBoxDiagramsPreSARAH of SARAH  *)
temp1=CalcAnalyticBoxes[DiagramDelete[boxes,{1,3}],2,ProcessFA,BoxOperators,FermionOrderBoxes,subZeroBoxes];
temp2=CalcAnalyticBoxes[DiagramDelete[boxes,{2,3}],1,ProcessFA,BoxOperators,FermionOrderBoxes,subZeroBoxes];
temp3=CalcAnalyticBoxes[DiagramDelete[boxes,{1,2}],3,ProcessFA,BoxOperators,FermionOrderBoxes,subZeroBoxes]; 
Return[{temp1,temp2,temp3}];
];





(*
CheckChiralityCoupling[coup_,nr_]:=Block[{skip},
If[FreeQ[coup,ChiralityProjector]&&FreeQ[coup,FormCalc`Private`ga],
Return[{coup->ToExpression["coup"<>ToString[nr]]}];
];
If[FreeQ[coup,ChiralityProjector[-1]//.FC8sub],
If[FreeQ[coup,-V[Index[__]]],
Return[{coup->ToExpression["coup"<>ToString[nr]<>"R"]}];,
Return[{coup->-ToExpression["coup"<>ToString[nr]<>"L"]}];
];,
If[FreeQ[coup,-V[Index[__]]],
Return[{coup->ToExpression["coup"<>ToString[nr]<>"L"]}];,
Return[{coup->-ToExpression["coup"<>ToString[nr]<>"R"]}];
];
];
];
*)


CheckChiralityCoupling[coup_,nr_]:=Block[{skip},
If[FreeQ[coup,ChiralityProjector]&&FreeQ[coup,FormCalc`Private`ga],
Return[{coup->ToExpression["coup"<>ToString[nr]]}];
];
If[FreeQ[coup,ChiralityProjector[-1]//.FC8sub],
Return[{coup->ToExpression["coup"<>ToString[nr]<>"R"]}];,
Return[{coup->ToExpression["coup"<>ToString[nr]<>"L"]}];
];
];


ReplaceVertexNamesPenguins[1]:=Block[{subCoups={},coups,i},(*We have to translate the vertices introduced by FeynArts to the conventions of SARAH/SPheno*)(*We count the vertices for penguins as follows*)(*(i) the vertex involving the first,external particle is coup1L,coup1R (for left/right)*)(*(ii) the vertex involving two other,external particles is coup4L,coup4R*)(*(iii) the vertex attaching the propagator to the loop is coup3 respectively coup3L,coup3R*)(*(iv) the remaining vertex (another external particle attached to the loop) is coup2L,coup2R*)coups=DeleteCases[Table[GenericList[][[i,2]],{i,1,Length[GenericList[]]}],x_Mass];

For[i=1,i<=Length[coups],
Switch[Length[Select[List@@coups[[i,0]],
(FreeQ[#,Generic]==False)&]],
1,subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],4]];,
2,If[FreeQ[coups[[i]],Pex1],
subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],2]];,
subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],1]];
];,
3,subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],3]];];
i++;];
Return[subCoups];
];
ReplaceVertexNamesPenguins[2]:=ReplaceVertexNamesPenguins[1];
ReplaceVertexNamesPenguins[3]:=ReplaceVertexNamesPenguins[1];

ReplaceVertexNamesPenguins[4]:=Block[{subCoups={},coups,i},(*We have to translate the vertices introduced by FeynArts to the conventions of SARAH/SPheno*)(*We count the vertices for penguins as follows*)(*(i) the vertex involving the first,external particle is coup1L,coup1R (for left/right)*)(*(ii) the vertex involving two other,external particles is coup4L,coup4R*)(*(iii) the vertex attaching the propagator to the loop is coup3 respectively coup3L,coup3R*)(*(iv) the remaining vertex (another external particle attached to the loop) is coup2L,coup2R*)coups=DeleteCases[Table[GenericList[][[i,2]],{i,1,Length[GenericList[]]}],x_Mass];

For[i=1,i<=Length[coups],
Switch[Length[Select[List@@coups[[i,0]],
(FreeQ[#,Generic]==False)&]],
1,subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],4]];,
2,If[FreeQ[coups[[i]],Pex3],
subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],2]];,
subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],1]];
];,
3,subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],3]];];
i++;];
Return[subCoups];
];

ReplaceVertexNamesPenguins[5]:=Block[{subCoups={},coups,i},(*We have to translate the vertices introduced by FeynArts to the conventions of SARAH/SPheno*)(*We count the vertices for penguins as follows*)(*(i) the vertex involving the first,external particle is coup1L,coup1R (for left/right)*)(*(ii) the vertex involving two other,external particles is coup4L,coup4R*)(*(iii) the vertex attaching the propagator to the loop is coup3 respectively coup3L,coup3R*)(*(iv) the remaining vertex (another external particle attached to the loop) is coup2L,coup2R*)coups=DeleteCases[Table[GenericList[][[i,2]],{i,1,Length[GenericList[]]}],x_Mass];

For[i=1,i<=Length[coups],
Switch[Length[Select[List@@coups[[i,0]],
(FreeQ[#,Generic]==False)&]],
1,subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],4]];,
2,If[FreeQ[coups[[i]],Pex2],
subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],2]];,
subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],1]];
];,
3,subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],3]];];
i++;];
Return[subCoups];
];

ReplaceVertexNamesPenguins[6]:=ReplaceVertexNamesPenguins[5];


ReplaceVertexNamesPenguins2F:=Block[{subCoups={},coups,i},
coups=DeleteCases[Table[GenericList[][[i,2]],{i,1,Length[GenericList[]]}],x_Mass];

For[i=1,i<=Length[coups],
If[FreeQ[coups[[i]],Pex1] &&FreeQ[coups[[i]],-Pex2],
subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],3]];
];
If[FreeQ[coups[[i]],Pex1] &&FreeQ[coups[[i]],Pex3],
subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],2]];
];
If[FreeQ[coups[[i]],-Pex2] &&FreeQ[coups[[i]],Pex3],
subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],1]];
];
i++;];
Return[subCoups];
];


ReplaceVertexNamesTree:=Block[{subCoups={},coups,i},coups=DeleteCases[Table[GenericList[][[i,2]],{i,1,Length[GenericList[]]}],x_Mass];
For[i=1,i<=Length[coups],If[FreeQ[coups[[i]],Pex1],subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],2]];,subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],1]];];
i++;];
Return[subCoups];];

ReplaceVertexNamesTree2F:=Block[{subCoups={},coups,i},coups=DeleteCases[Table[GenericList[][[i,2]],{i,1,Length[GenericList[]]}],x_Mass];
For[i=1,i<=Length[coups],
subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],1]];
i++;];
Return[subCoups];];

ReplaceVertexNamesWave:=Block[{subCoups={},coups,i},(*We have to translate the vertices introduced by FeynArts to the conventions of SARAH/SPheno*)coups=DeleteCases[Table[GenericList[][[i,2]],{i,1,Length[GenericList[]]}],x_Mass];
(*To Do:Change PL/PR of FFV couplings in wave and penguin loops!*)
For[i=1,i<=Length[coups],
Switch[Length[Select[List@@coups[[i,0]],(FreeQ[#,Generic]==False)&]],
1,subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],4]];,
2,If[FreeQ[coups[[i]],Index[Generic,5]]==False,
subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],3]];,
subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],1]];
];,
3,subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],2]];];
i++;];
Return[subCoups];];

ReplaceVertexNamesWave2F:=Block[{subCoups={},coups,i},(*We have to translate the vertices introduced by FeynArts to the conventions of SARAH/SPheno*)coups=DeleteCases[Table[GenericList[][[i,2]],{i,1,Length[GenericList[]]}],x_Mass];
(*To Do:Change PL/PR of FFV couplings in wave and penguin loops!*)For[i=1,i<=Length[coups],
Switch[Length[Select[List@@coups[[i,0]],(FreeQ[#,Generic]==False)&]],
1,subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],3]];,
2,subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],1]];,
3,subCoups=Join[subCoups,CheckChiralityCoupling[coups[[i]],2]];
];
i++;];
Return[subCoups];];

CalcAnalyticPenguins[top_,process_,fermionorder_,neglect_,nr_]:=Block[{i,j,k,len,all,resultS={},resultV={},resultP={},internalfields,sub},
ampSave={};
ins=InsertFields[top,process,InsertionLevel->{Generic}];
If[AddScalars=!=True,
ins=DiagramDelete[ins,Transpose[Position[ins,Field[5]->S]][[3]]]
];
If[AddVectors=!=True,
ins=DiagramDelete[ins,Transpose[Position[ins,Field[5]->V]][[3]]]
];
len=Length[ins[[1,2]]];
For[i=1,i<=len,Print["Diagram Nr.",i];
dia=DiagramDelete[ins,Delete[Table[j,{j,1,len}],i]];
Paint[dia];
ClearProcess[];
amp=CalcFeynAmp[CreateFeynAmp[dia],FermionChains->Chiral,FermionOrder->fermionorder,Dimension->PS`DimensionsLoop,PaVeReduce->False,Invariants->False];
ampFull=amp//.Subexpr[]//.Abbr[]/.GenericList[]//.FC8sub//.subExternalMasses//.FormCalc`S23->0//.FormCalc`T12->0;
amp=amp//.Subexpr[]//.Abbr[]/.GenericList[]//.FC8sub//.subExternalMasses//.neglect//.FormCalc`S23->0//.FormCalc`T12->0;
internalfields=List@@dia[[1,2,1]];
sub=GenerateSubstitutionsPenguins[{Field[6],Field[7],Field[8]}/.internalfields];
(*amp=amp//.sub//.ec[3]->Lor[1];*)amp=amp//.sub;
ampFull=ampFull//.sub;
ampSave=Join[ampSave,{amp}];
Switch[Field[5]/.internalfields,
S,resultS=Join[resultS,{{{Field[6],Field[7],Field[8]}/.internalfields,Table[{ScalarPenguinOperators[[j,1]],FullSimplify[Expand[Expand[ PS`sign 16*Pi^2*Coefficient[Expand[amp[[1]]],Mat[ScalarPenguinOperators[[j,2]]/.neglect]]]//.subLoopIntegrals//.ReplaceVertexNamesPenguins[nr]//.sub//.subfinal //.Den[a__]->-IMP2/.Pair[a__]->0//.subExternalMasses]//.subLoopIntegralsCombinations]//.subLoopIntegralsCombinations},{j,1,Length[ScalarPenguinOperators]}]}}];,
V,
resultV=Join[resultV,{{{Field[6],Field[7],Field[8]}/.internalfields,Table[{VectorPenguinOperators[[j,1]],FullSimplify[Expand[Expand[ PS`sign  16*Pi^2*Coefficient[Expand[amp[[1]]],Mat[VectorPenguinOperators[[j,2]]/.neglect]]]//.subLoopIntegrals//.ReplaceVertexNamesPenguins[nr]//.sub//.subfinal //.subLoopIntegralsCombinations//.Den[a__]->-IMP2/.Pair[a__]->0//.subExternalMasses/.MassA2->0/.MassB2->0 /.neglect/.subZeroBoxes]//. subLoopIntegralsCombinations]//. subLoopIntegralsCombinations},{j,1,Length[VectorPenguinOperators]}]}}];

(*
resultP=Join[resultP,{{{Field[6],Field[7],Field[8]}/.internalfields,Table[{PhotonPenguinOperators[[j,1]],Expand[16*Pi^2*Coefficient[Expand[ampFull[[1]]]//.Den[a__]->1,Mat[PhotonPenguinOperators[[j,2]]]]]//.subLoopIntegrals//.ReplaceVertexNamesPenguins//.sub//.subfinal/.Pair[a__]->0//.subExternalMasses/.MassA2->0/.MassB2->0/.MassB->0},{j,1,Length[VectorPenguinOperators]}]}}];
*)
];
i++;];
Return[{resultV,resultS,resultP}];];

CalcAnalyticPenguins2Fermion[top_,process_,fermionorder_,neglect_]:=Block[{i,j,k,len,all,resultS={},resultV={},resultP={},internalfields,sub,arg1,arg2,arg3},
ampSave={};
ins=InsertFields[top,process,InsertionLevel->{Generic}];
len=Length[ins[[1,2]]];
For[i=1,i<=len,Print["Diagram Nr.",i];
dia=DiagramDelete[ins,Delete[Table[j,{j,1,len}],i]];
Paint[dia];
ClearProcess[];
amp=CalcFeynAmp[CreateFeynAmp[dia],FermionChains->Chiral,FermionOrder->fermionorder,Dimension->PS`DimensionsLoop,PaVeReduce->False,Invariants->False,OnShell->UseOneShell];
ampFull=amp//.Subexpr[]//.Abbr[]/.GenericList[]//.FC8sub//.subExternalMasses//.FormCalc`S23->0//.FormCalc`T12->0;
amp=amp//.Subexpr[]//.Abbr[]/.GenericList[]//.FC8sub//.subExternalMasses//.neglect//.FormCalc`S23->0//.FormCalc`T12->0;
internalfields=List@@dia[[1,2,1]];
sub=GenerateSubstitutionsPenguins2F[{Field[4],Field[5],Field[6]}/.internalfields];
amp=amp//.sub;
ampFull=ampFull//.sub;
ampSave=Join[ampSave,{amp}];
If[subMasslessBoson=!={},
arg1=Select[Flatten[Expand[amp[[1]] ] /. Plus->List  /. Times->List],Head[#]===C0i&,1][[1,5]];
arg2=Select[Flatten[Expand[amp[[1]] ] /. Plus->List  /. Times->List],Head[#]===C0i&,1][[1,6]];
arg3=Select[Flatten[Expand[amp[[1]] ] /. Plus->List  /. Times->List],Head[#]===C0i&,1][[1,7]];

subArgs=subMasslessBosonsArgs/. {ARG1->arg1,ARG2->arg2,ARG3->arg3} //. subfinal;

];

resultS=Join[resultS,{{{Field[4],Field[5],Field[6]}/.internalfields,Table[{TriangleOperators[[j,1]],FullSimplifySort[Expand[ PS`sign 16*Pi^2*Coefficient[Expand[(amp[[1]]+CheckMonopoleContribution[(Mat[TriangleOperators[[j,2]]/.neglect]/. Mat[a_ Pair[b__]]->Pair[b] Mat[a]),{Field[4],Field[5],Field[6]}/.internalfields])/I],(Mat[TriangleOperators[[j,2]]/.neglect]/. Mat[a_ Pair[b__]]->Pair[b] Mat[a])]]//.subMasslessBoson//.subLoopIntegrals //.subLoopIntegralsCombinations//.ReplaceVertexNamesPenguins2F//.subMasslessBoson//.sub//.subfinal //.subLoopIntegralsCombinations//.Den[a__]->-IMP2(* /.Pair[ec[_],b_]->1*)/.Pair[a__]->0//.subExternalMasses]//.subLoopIntegralsCombinations //. subMasslessBosonsSums /. subArgs  },{j,1,Length[TriangleOperators]}]}}];
i++;];
Return[resultS];
];

FullSimplifySort[x_]:=If[subMasslessBoson==={},
Return[FullSimplify[x];];,
Return[MassEx1 Simplify[Coefficient[Expand[x],MassEx1]]+MassEx2 Simplify[Coefficient[Expand[x],MassEx2]]+mF1 Simplify[Coefficient[Expand[x],mF1]]+ mF2 Simplify[Coefficient[Expand[x],mF2]]+Simplify[x /. {MassEx1->0,MassEx2->0,mF1->0,mF2->0}]];
];

CheckMonopoleContribution[operator_,{a_,b_,c_}]:=Block[{i,j,res},
res=0;
If[(operator /. Mat[DiracChain[x_,y__,z_]]->Op[y])===Pair[k[3],k[3]]*Op[6,ec[3]],
Switch[{a,b,c},
{F,S,S},res=coup1R*coup2L*coup3*MonopoleFSS[mF12,mS12,mS22];,
{S,F,F},res=-coup1R*coup2L*coup3L*MonopoleSFF[mS12,mF12,mF22];,
{F,S,V},res=coup1L*coup2R*coup3*MonopoleFSV[mF12,mS12,mV22];,
{F,V,S},res=coup1L*coup2L*coup3*MonopoleFVS[mF12,mV12,mS22];,
{F,V,V},res=coup1L*coup2L*coup3*MonopoleFVV[mF12,mV12,mV22];,
{V,F,F},res=coup1L*coup2L*coup3L*MonopoleVFF[mV12,mF12,mF22];
];,
If[(operator /. Mat[DiracChain[x_,y__,z_]]->Op[y])===Pair[k[3],k[3]]*Op[7,ec[3]],
Switch[{a,b,c},
{F,S,S},res=coup1L*coup2R*coup3*MonopoleFSS[mF12,mS12,mS22];,
{S,F,F},res=-coup1L*coup2R*coup3L*MonopoleSFF[mS12,mF12,mF22];,
{F,S,V},res=coup1R*coup2L*coup3*MonopoleFSV[mF12,mS12,mV22];,
{F,V,S},res=coup1R*coup2R*coup3*MonopoleFVS[mF12,mV12,mS22];,
{F,V,V},res=coup1R*coup2R*coup3*MonopoleFVV[mF12,mV12,mV22];,
{V,F,F},res=coup1R*coup2R*coup3L*MonopoleVFF[mV12,mF12,mF22];
];,
res=0;
];
];
Return[res*operator I /(16 Pi^2)];
];

CalcAnalyticTree[top_,process_,fermionorder_,neglect_]:=Block[{i,j,k,len,all,resultS={},resultV={},resultP={},internalfields,sub},ins=InsertFields[top,process,InsertionLevel->{Generic}];
len=Length[ins[[1,2]]];
For[i=1,i<=len,Print["Diagram Nr.",i];
dia=DiagramDelete[ins,Delete[Table[j,{j,1,len}],i]];
Paint[dia];
ClearProcess[];
amp=CalcFeynAmp[CreateFeynAmp[dia],FermionChains->Chiral,FermionOrder->fermionorder,Dimension->PS`DimensionsLoop,PaVeReduce->False,Invariants->False];
ampFull=amp//.Subexpr[]//.Abbr[]/.GenericList[]//.FC8sub//.subExternalMasses//.FormCalc`S23->0//.FormCalc`T12->0;
amp=amp//.Subexpr[]//.Abbr[]/.GenericList[]//.FC8sub//.subExternalMasses//.neglect//.FormCalc`S23->0//.FormCalc`T12->0;
internalfields=List@@dia[[1,2,1]];
(* sub=GenerateSubstitutionsTree[{Field[6],Field[7],Field[8]}/.internalfields]; *)
(*amp=amp//.sub//.ec[3]->Lor[1];*)
(* amp=amp//.sub;
ampFull=ampFull//.sub; *)
Switch[Field[5]/.internalfields,
S,resultS=Join[resultS,{{{},Table[{ScalarTreeOperators[[j,1]],Expand[Coefficient[PS`sign Expand[amp[[1]]],Mat[ScalarTreeOperators[[j,2]]/.neglect]]]//.subLoopIntegrals//.ReplaceVertexNamesTree (*//.sub *)//.subfinal//.Den[a__]->-IMP2/.Pair[a__]->0//.subExternalMasses},{j,1,Length[ScalarTreeOperators]}]}}];,V,resultV=Join[resultV,{{{},Table[{VectorTreeOperators[[j,1]],Expand[Coefficient[PS`sign  Expand[amp[[1]]],Mat[VectorTreeOperators[[j,2]]/.neglect]]]//.subLoopIntegrals//.ReplaceVertexNamesTree(*//.sub *)//.subfinal//.Den[a__]->-IMP2/.Pair[a__]->0//.subExternalMasses/.MassA2->0/.MassB2->0/.subZeroBoxes},{j,1,Length[VectorTreeOperators]}]}}];
(*
resultP=Join[resultP,{{{Field[6],Field[7],Field[8]}/.internalfields,Table[{PhotonPenguinOperators[[j,1]],Expand[16*Pi^2*Coefficient[Expand[ampFull[[1]]]//.Den[a__]->1,Mat[PhotonPenguinOperators[[j,2]]]]]//.subLoopIntegrals//.ReplaceVertexNamesPenguins//.sub//.subfinal/.Pair[a__]->0//.subExternalMasses/.MassA2->0/.MassB2->0/.MassB->0},{j,1,Length[VectorPenguinOperators]}]}}];
*)
];
i++;];
Return[{resultV,resultS,resultP}];];

CalcAnalyticTree2Fermion[top_,process_,fermionorder_,neglect_]:=Block[{i,j,k,len,all,resultS={},resultV={},resultP={},internalfields,sub},
ins=InsertFields[top,process /. {V[3]->V[2],S[3]->S[2],F[2,{a__}]->F[3,{1}]},InsertionLevel->{Generic}];
len=Length[ins[[1,2]]];
For[i=1,i<=len,Print["Diagram Nr.",i];
dia=DiagramDelete[ins,Delete[Table[j,{j,1,len}],i]];
Paint[dia];
ClearProcess[];
amp=CalcFeynAmp[CreateFeynAmp[dia],FermionChains->Chiral,FermionOrder->fermionorder,Dimension->PS`DimensionsLoop,PaVeReduce->False,Invariants->False];
ampFull=amp//.Subexpr[]//.Abbr[]/.GenericList[]//.FC8sub//.subExternalMasses//.FormCalc`S23->0//.FormCalc`T12->0;
amp=amp//.Subexpr[]//.Abbr[]/.GenericList[]//.FC8sub//.subExternalMasses//.neglect//.FormCalc`S23->0//.FormCalc`T12->0;
internalfields=List@@dia[[1,2,1]];
resultS=Join[resultS,{{{},Table[{TriangleOperators[[j,1]],Expand[Coefficient[PS`sign  16*Pi^2* Expand[amp[[1]]/I],(Mat[TriangleOperators[[j,2]]/.neglect]/. Mat[a_ Pair[b__]]->Pair[b] Mat[a])]]//.subLoopIntegrals//.ReplaceVertexNamesTree2F (*//.sub *)//.subfinal//.Den[a__]->-IMP2/.Pair[a__]->0//.subExternalMasses},{j,1,Length[TriangleOperators]}]}}];
i++;];
Return[resultS];
];

CalcAnalyticWave[top_,process_,fermionorder_,neglect_]:=Block[{i,j,k,len,all,resultS={},resultV={},resultP={},internalfields,sub},
ins=InsertFields[top,process,InsertionLevel->{Generic}];
If[AddScalars=!=True,
ins=DiagramDelete[ins,Transpose[Position[ins,Field[5]->S]][[3]]]
];
If[AddVectors=!=True,
ins=DiagramDelete[ins,Transpose[Position[ins,Field[5]->V]][[3]]]
];
len=Length[ins[[1,2]]];
For[i=1,i<=len,Print["Diagram Nr.",i];
dia=DiagramDelete[ins,Delete[Table[j,{j,1,len}],i]];
Paint[dia];
ClearProcess[];
amp=CalcFeynAmp[CreateFeynAmp[dia],FermionChains->Chiral,FermionOrder->fermionorder,Dimension->PS`DimensionsLoop,Invariants->False];
amp=amp//.Subexpr[]/.Abbr[]/.GenericList[]//.FC8sub//.subExternalMasses//.neglect//.FormCalc`S23->0//.FormCalc`T12->0;
ampFull=amp//.Subexpr[]/.Abbr[]/.GenericList[]//.FC8sub//.subExternalMasses//.FormCalc`S23->0//.FormCalc`T12->0;
internalfields=List@@dia[[1,2,1]];
sub=GenerateSubstitutionsWave[{Field[7],Field[8]}/.internalfields];
(*amp=amp//.sub//.ec[3]->Lor[1];*)amp=amp//.sub;
ampFull=ampFull//.sub;
Switch[Field[5]/.internalfields,
S,resultS=Join[resultS,{{{Field[7],Field[8]}/.internalfields,Table[{ScalarPenguinOperators[[j,1]],Expand[PS`sign  16*Pi^2*Coefficient[Expand[amp[[1]]],Mat[ScalarWaveOperators[[j,2]]/.neglect]]]//.subLoopIntegrals//.ReplaceVertexNamesWave//.sub//.subfinal//.Den[a_,Mass[S[b_],c_]^2]->-IMP2//.Den[a__,MFin2]->1/(a-MFin2)},{j,1,Length[ScalarPenguinOperators]}]}}];,V,resultV=Join[resultV,{{{Field[7],Field[8]}/.internalfields,Table[{VectorPenguinOperators[[j,1]],Expand[PS`sign  16*Pi^2*Coefficient[Expand[amp[[1]]],Mat[VectorWaveOperators[[j,2]]/.neglect]]]//.subLoopIntegrals//.ReplaceVertexNamesWave//.sub//.subfinal//.Den[a_,Mass[V[b_],c_]^2]->-IMP2//.Den[a__,MFin2]->1/(a-MFin2)},{j,1,Length[VectorPenguinOperators]}]}}];
(*
resultP=Join[resultP,{{{Field[7],Field[8]}/.internalfields,Table[{PhotonWaveOperators[[j,1]],Expand[16*Pi^2*Coefficient[Expand[ampFull[[1]]//.Den[a_,Mass[V[b_],c_]^2]->1],Mat[PhotonWaveOperators[[j,2]]]]]//.subLoopIntegrals//.ReplaceVertexNamesWave//.sub//.subfinal//.Den[a__,MFin2]->1/(a-MFin2)},{j,1,Length[VectorPenguinOperators]}]}}];
*)
];
i++;];
Return[{resultV,resultS,resultP}];];

CalcAnalyticWave2Fermion[top_,process_,fermionorder_,neglect_]:=Block[{i,j,k,len,all,resultS={},resultV={},resultP={},internalfields,sub},
ins=InsertFields[top,process,InsertionLevel->{Generic}];
len=Length[ins[[1,2]]];
For[i=1,i<=len,Print["Diagram Nr.",i];
dia=DiagramDelete[ins,Delete[Table[j,{j,1,len}],i]];
Paint[dia];
ClearProcess[];
amp=CalcFeynAmp[CreateFeynAmp[dia],FermionChains->Chiral,FermionOrder->fermionorder,Dimension->PS`DimensionsLoop,Invariants->False,OnShell->UseOneShell];
amp=amp//.Subexpr[]/.Abbr[]/.GenericList[]//.FC8sub//.subExternalMasses//.neglect//.FormCalc`S23->0//.FormCalc`T12->0;
ampFull=amp//.Subexpr[]/.Abbr[]/.GenericList[]//.FC8sub//.subExternalMasses//.FormCalc`S23->0//.FormCalc`T12->0;
internalfields=List@@dia[[1,2,1]];
sub=GenerateSubstitutionsWave2F[{Field[5],Field[6]}/.internalfields];
(*amp=amp//.sub//.ec[3]->Lor[1];*)amp=amp//.sub;
ampFull=ampFull//.sub;
resultS=Join[resultS,{{{Field[5],Field[6]}/.internalfields,Table[{TriangleOperators[[j,1]],Expand[PS`sign  16*Pi^2*Coefficient[Expand[amp[[1]]/I],(Mat[TriangleOperators[[j,2]]/.neglect]/. Mat[a_ Pair[b__]]->Pair[b] Mat[a])]]//.subLoopIntegrals//.ReplaceVertexNamesWave2F//.sub//.subfinal//.Den[a_,Mass[S[b_],c_]^2]->-IMP2//.Den[a__,MFin2]->1/(a-MFin2)},{j,1,Length[TriangleOperators]}]}}];
i++;];
Return[resultS];];


GenerateSubstitutionsPenguins[{p1_,p2_,p3_}]:=Block[{temp={}},
Switch[p1,F,temp=Join[temp,{Mass[F[Index[Generic,6]],Loop]->mF1}];
If[p2===V,temp=Join[temp,{Mass[V[Index[Generic,7]],Loop]->mV1}];,temp=Join[temp,{Mass[S[Index[Generic,7]],Loop]->mS1}];];
If[p3===V,temp=Join[temp,{Mass[V[Index[Generic,8]],Loop]->mV2}];,temp=Join[temp,{Mass[S[Index[Generic,8]],Loop]->mS2}];];,S,temp=Join[temp,{Mass[S[Index[Generic,6]],Loop]->mS1,Mass[F[Index[Generic,7]],Loop]->mF1,Mass[F[Index[Generic,8]],Loop]->mF2}];,V,temp=Join[temp,{Mass[V[Index[Generic,6]],Loop]->mV1,Mass[F[Index[Generic,7]],Loop]->mF1,Mass[F[Index[Generic,8]],Loop]->mF2}];];
Return[temp];];

GenerateSubstitutionsPenguins2F[{p1_,p2_,p3_}]:=Block[{temp={}},
Switch[p1,F,temp=Join[temp,{Mass[F[Index[Generic,4]],Loop]->mF1}];
If[p2===V,temp=Join[temp,{Mass[V[Index[Generic,5]],Loop]->mV1}];,temp=Join[temp,{Mass[S[Index[Generic,5]],Loop]->mS1}];];
If[p3===V,temp=Join[temp,{Mass[V[Index[Generic,6]],Loop]->mV2}];,temp=Join[temp,{Mass[S[Index[Generic,6]],Loop]->mS2}];];,S,temp=Join[temp,{Mass[S[Index[Generic,4]],Loop]->mS1,Mass[F[Index[Generic,5]],Loop]->mF1,Mass[F[Index[Generic,6]],Loop]->mF2}];,V,temp=Join[temp,{Mass[V[Index[Generic,4]],Loop]->mV1,Mass[F[Index[Generic,5]],Loop]->mF1,Mass[F[Index[Generic,6]],Loop]->mF2}];];
Return[temp];];

GenerateSubstitutionsWave[{p1_,p2_}]:=Block[{temp={}},temp=Join[temp,{Mass[F[Index[Generic,6]],Internal]->MFin}];
Switch[p1,F,temp=Join[temp,{Mass[F[Index[Generic,7]],Loop]->mF1}];
If[p2===V,temp=Join[temp,{Mass[V[Index[Generic,8]],Loop]->mV1}];,temp=Join[temp,{Mass[S[Index[Generic,8]],Loop]->mS1}];];,S,temp=Join[temp,{Mass[S[Index[Generic,7]],Loop]->mS1,Mass[F[Index[Generic,8]],Loop]->mF1}];,V,temp=Join[temp,{Mass[V[Index[Generic,7]],Loop]->mV1,Mass[F[Index[Generic,8]],Loop]->mF1}];];
Return[temp];];

GenerateSubstitutionsWave2F[{p1_,p2_}]:=
Block[{temp={}},
temp=Join[temp,{Mass[F[Index[Generic,4]],Internal]->MFin}];
Switch[p1,F,temp=Join[temp,{Mass[F[Index[Generic,5]],Loop]->mF1}];
If[p2===V,temp=Join[temp,{Mass[V[Index[Generic,6]],Loop]->mV1}];,temp=Join[temp,{Mass[S[Index[Generic,6]],Loop]->mS1}];];,S,temp=Join[temp,{Mass[S[Index[Generic,5]],Loop]->mS1,Mass[F[Index[Generic,6]],Loop]->mF1}];,V,temp=Join[temp,{Mass[V[Index[Generic,5]],Loop]->mV1,Mass[F[Index[Generic,6]],Loop]->mF1}];];
Return[temp];];





CalculateAllPenguins:=Block[{i,temp,tempVector={},tempScalar={},tempPhoton={}},
temp=CalcAnalyticPenguins[DiagramDelete[penguins,{1,2,4,5,6}],ProcessFA,FermionOrderBoxes,subZeroBoxes,1];
tempVector=Join[tempVector,{temp[[1]]}];
tempScalar=Join[tempScalar,{temp[[2]]}];
tempPhoton=Join[tempPhoton,{temp[[3]]}];

temp=CalcAnalyticPenguins[DiagramDelete[penguins,{1,3,4,5,6}],ProcessFA,FermionOrderBoxes,subZeroBoxes,2];
tempVector=Join[tempVector,{temp[[1]]}];
tempScalar=Join[tempScalar,{temp[[2]]}];
tempPhoton=Join[tempPhoton,{temp[[3]]}];

temp=CalcAnalyticPenguins[DiagramDelete[penguins,{2,3,4,5,6}],ProcessFA,FermionOrderBoxes,subZeroBoxes,3];
tempVector=Join[tempVector,{temp[[1]]}];
tempScalar=Join[tempScalar,{temp[[2]]}];
tempPhoton=Join[tempPhoton,{temp[[3]]}];

temp=CalcAnalyticPenguins[DiagramDelete[penguins,{1,2,3,5,6}],ProcessFA,FermionOrderBoxes,subZeroBoxes,4];
tempVector=Join[tempVector,{temp[[1]]}];
tempScalar=Join[tempScalar,{temp[[2]]}];
tempPhoton=Join[tempPhoton,{temp[[3]]}];

temp=CalcAnalyticPenguins[DiagramDelete[penguins,{1,2,3,4,6}],ProcessFA,FermionOrderBoxes,subZeroBoxes,5];
tempVector=Join[tempVector,{temp[[1]]}];
tempScalar=Join[tempScalar,{temp[[2]]}];
tempPhoton=Join[tempPhoton,{temp[[3]]}];

temp=CalcAnalyticPenguins[DiagramDelete[penguins,{1,2,3,4,5}],ProcessFA,FermionOrderBoxes,subZeroBoxes,6];
tempVector=Join[tempVector,{temp[[1]]}];
tempScalar=Join[tempScalar,{temp[[2]]}];
tempPhoton=Join[tempPhoton,{temp[[3]]}];

Return[{tempVector,tempScalar,tempPhoton}];
];

CalculateAllTree:=Block[{i,temp,tempVector={},tempScalar={},tempPhoton={}},
temp=CalcAnalyticTree[DiagramDelete[tree,{2,3}],ProcessFA,FermionOrderBoxes,subZero];
tempVector=Join[tempVector,{temp[[1]]}];
tempScalar=Join[tempScalar,{temp[[2]]}];
tempPhoton=Join[tempPhoton,{temp[[3]]}];

temp=CalcAnalyticTree[DiagramDelete[tree,{1,3}],ProcessFA,FermionOrderBoxes,subZero];
tempVector=Join[tempVector,{temp[[1]]}];
tempScalar=Join[tempScalar,{temp[[2]]}];
tempPhoton=Join[tempPhoton,{temp[[3]]}];

temp=CalcAnalyticTree[DiagramDelete[tree,{1,2}],ProcessFA,FermionOrderBoxes,subZero];
tempVector=Join[tempVector,{temp[[1]]}];
tempScalar=Join[tempScalar,{temp[[2]]}];
tempPhoton=Join[tempPhoton,{temp[[3]]}];

Return[{tempVector,tempScalar,tempPhoton}];
];

CalculateAllWave2Fermion:=Block[{i,temp,tempVector={},tempScalar={},tempPhoton={},tempAll},
(* Wave diagrams*)
temp=CalcAnalyticWave2Fermion[DiagramDelete[waves,{1}],ProcessFA,FermionOrderBoxes,{}];
tempAll={temp};
temp=CalcAnalyticWave2Fermion[DiagramDelete[waves,{2}],ProcessFA,FermionOrderBoxes,{}];
tempAll=Join[tempAll,{temp}];
Return[tempAll];
];

CalculateAllPenguins2Fermion:=Block[{i,temp,tempVector={},tempScalar={},tempPhoton={}},
temp=CalcAnalyticPenguins2Fermion[triangle,ProcessFA,FermionOrderBoxes,subZeroBoxes];
Return[{temp}];
];

CalculateAllTree2Fermion:=Block[{i,temp,tempVector={},tempScalar={},tempPhoton={}},
temp=CalcAnalyticTree2Fermion[tree,ProcessFA,FermionOrderBoxes,subZero];
Return[{temp}];
];

CalculateAllWave:=Block[{i,temp,tempVector={},tempScalar={},tempPhoton={},tempAll},
(* Wave diagrams*)
temp=CalcAnalyticWave[DiagramDelete[waves,{1,2,3,4,5,7,8,9,10,11,12}],ProcessFA,FermionOrderBoxes,{}];
tempVector=Join[tempVector,{temp[[1]]}];
tempScalar=Join[tempScalar,{temp[[2]]}];
tempPhoton=Join[tempPhoton,{temp[[3]]}];

temp=CalcAnalyticWave[DiagramDelete[waves,{1,2,3,4,6,7,8,9,10,11,12}],ProcessFA,FermionOrderBoxes,{}];
tempVector=Join[tempVector,{temp[[1]]}];
tempScalar=Join[tempScalar,{temp[[2]]}];
tempPhoton=Join[tempPhoton,{temp[[3]]}];

(* 3/4 *)
temp=CalcAnalyticWave[DiagramDelete[waves,{1,2,3,5,6,7,8,9,10,11,12}],ProcessFA,FermionOrderBoxes,{}];
tempVector=Join[tempVector,{temp[[1]]}];
tempScalar=Join[tempScalar,{temp[[2]]}];
tempPhoton=Join[tempPhoton,{temp[[3]]}];

temp=CalcAnalyticWave[DiagramDelete[waves,{1,2,4,5,6,7,8,9,10,11,12}],ProcessFA,FermionOrderBoxes,{}];
tempVector=Join[tempVector,{temp[[1]]}];
tempScalar=Join[tempScalar,{temp[[2]]}];
tempPhoton=Join[tempPhoton,{temp[[3]]}];

(* 5/6 *)
temp=CalcAnalyticWave[DiagramDelete[waves,{2,3,4,5,6,7,8,9,10,11,12}],ProcessFA,FermionOrderBoxes,{}];
tempVector=Join[tempVector,{temp[[1]]}];
tempScalar=Join[tempScalar,{temp[[2]]}];
tempPhoton=Join[tempPhoton,{temp[[3]]}];

temp=CalcAnalyticWave[DiagramDelete[waves,{1,3,4,5,6,7,8,9,10,11,12}],ProcessFA,FermionOrderBoxes,{}];
tempVector=Join[tempVector,{temp[[1]]}];
tempScalar=Join[tempScalar,{temp[[2]]}];
tempPhoton=Join[tempPhoton,{temp[[3]]}];

(* 7/8 *)
temp=CalcAnalyticWave[DiagramDelete[waves,{1,2,3,4,5,6,7,9,10,11,12}],ProcessFA,FermionOrderBoxes,{}];
tempVector=Join[tempVector,{temp[[1]]}];
tempScalar=Join[tempScalar,{temp[[2]]}];
tempPhoton=Join[tempPhoton,{temp[[3]]}];

temp=CalcAnalyticWave[DiagramDelete[waves,{1,2,3,4,5,6,8,9,10,11,12}],ProcessFA,FermionOrderBoxes,{}];
tempVector=Join[tempVector,{temp[[1]]}];
tempScalar=Join[tempScalar,{temp[[2]]}];
tempPhoton=Join[tempPhoton,{temp[[3]]}];

(* 9/10 *)
temp=CalcAnalyticWave[DiagramDelete[waves,{1,2,3,4,5,6,7,8,9,11,12}],ProcessFA,FermionOrderBoxes,{}];
tempVector=Join[tempVector,{temp[[1]]}];
tempScalar=Join[tempScalar,{temp[[2]]}];
tempPhoton=Join[tempPhoton,{temp[[3]]}];

temp=CalcAnalyticWave[DiagramDelete[waves,{1,2,3,4,5,6,7,8,10,11,12}],ProcessFA,FermionOrderBoxes,{}];
tempVector=Join[tempVector,{temp[[1]]}];
tempScalar=Join[tempScalar,{temp[[2]]}];
tempPhoton=Join[tempPhoton,{temp[[3]]}];

(* 11/12 *)
temp=CalcAnalyticWave[DiagramDelete[waves,{1,2,3,4,5,6,7,8,9,10,11}],ProcessFA,FermionOrderBoxes,{}];
tempVector=Join[tempVector,{temp[[1]]}];
tempScalar=Join[tempScalar,{temp[[2]]}];
tempPhoton=Join[tempPhoton,{temp[[3]]}];

temp=CalcAnalyticWave[DiagramDelete[waves,{1,2,3,4,5,6,7,8,9,10,12}],ProcessFA,FermionOrderBoxes,{}];
tempVector=Join[tempVector,{temp[[1]]}];
tempScalar=Join[tempScalar,{temp[[2]]}];
tempPhoton=Join[tempPhoton,{temp[[3]]}];

Return[{tempVector,tempScalar,tempPhoton}];
];


Start[file_]:=GetCodeForSARAH[file];
GetCodeForSARAH[file_]:=Block[{temp,dir},
Get[ToFileName[{$preSARAHdir,"Input"},file]];
If[ConsideredProcess==="4Fermion",
CreateDirectory[ToFileName[{$preSARAHdir,"Input",NameProcess}]];
CreateTemporyInput[NameProcess,FermionOrderExternal,ConsideredProcess, NeglectMasses,ExternalFields,CombinationGenerations,  AllOperators,MemberQ[Filters,NoCrossedDiagrams],ColorFlow];
WriteWrapper[NameProcess,ExternalFields,AllOperators];
dir=NameProcess;
Clear[NameProcess,FermionOrderBoxes,ConsideredProcess, NeglectMasses,ExternalFields,CombinationGenerations,  AllOperators, NeglectCrossedDiagrams,Filters,ColorFlow];
GetCodeForSARAHfromDirectory[dir];,
GetOperators[file];
];
];

WriteWrapper[name_,fields_,ops_]:=Block[{i,j,out,types},
CreateDirectory[ToFileName[{$preSARAHdir,"Output",name}]];
out=OpenWrite[ToFileName[{$preSARAHdir,"Output",name},name<>"_"<>"wrapper"<>".m"]];
WriteString[out,"(* Code automatically generated by 'PreSARAH' *) \n"];
Minutes=If[Date[][[5]]<10,"0"<>ToString[Date[][[5]]],ToString[Date[][[5]]]];
WriteString[out,"(* Created at "<>ToString[Date[][[4]]]<>":"<>Minutes<>" on "<>ToString[Date[][[3]]]<>"."<>ToString[Date[][[2]]]<>"."<>ToString[Date[][[1]]]<>" *) \n \n \n"];

types={"PV","PS","TV","TS","B"};
If[MemberQ[Filters,NoBoxes],types=DeleteCases[types,"B"];];
If[MemberQ[Filters,NoPenguins],types=DeleteCases[DeleteCases[types,"PV"],"PS"];];
If[MemberQ[Filters,NoTree],types=DeleteCases[DeleteCases[types,"TV"],"TS"];];

WriteString[out,"ProcessWrapper = True; \n"];
WriteString[out,"NameProcess = \""<>name<>"\" \n"];
WriteString[out,"ExternalFields = "<>ToString[fields]<>"; \n"];
WriteString[out,"SumContributionsOperators[\""<>name<>"\"] = { \n"];
For[i=1,i<=Length[ops],
WriteString[out,"{"<>ToString[ops[[i,1]]]<>", "<>ToString[Sum[ToExpression[types[[j]]<>ToString[ops[[i,1]]]],{j,1,Length[types]}]]<>"}"];
If[i<Length[ops],WriteString[out,", \n"];];
i++;];
WriteString[out,"}; \n\n"];
Close[out];

];

CreateTemporyInput[name_,order_,process_, neglect_,fields_,combis_,  ops_,crossed_,color_]:=Block[{i,types},
types={"PengV","PengS","TreeV","TreeS","Box"};

If[MemberQ[Filters,NoBoxes],types=DeleteCases[types,"Box"];];
If[MemberQ[Filters,NoPenguins],types=DeleteCases[DeleteCases[types,"PengV"],"PengS"];];
If[MemberQ[Filters,NoTree],types=DeleteCases[DeleteCases[types,"TreeV"],"TreeS"];];


For[i=1,i<=Length[types],
CreateTemporyInput[name,order,process, neglect,fields,combis,  ops,types[[i]],crossed,color];
i++;];
];

CreateTemporyInput[name_,order_,process_, neglect_,fields_,combis_,  ops_,type_,crossed_,color_]:=Block[{i,types,out,pre,nameop},
out=OpenWrite[ToFileName[{$preSARAHdir,"Input",name},name<>"_"<>type<>".m"]];

WriteString[out,"(* Code automatically generated by 'PreSARAH' *) \n"];
Minutes=If[Date[][[5]]<10,"0"<>ToString[Date[][[5]]],ToString[Date[][[5]]]];
WriteString[out,"(* Created at "<>ToString[Date[][[4]]]<>":"<>Minutes<>" on "<>ToString[Date[][[3]]]<>"."<>ToString[Date[][[2]]]<>"."<>ToString[Date[][[1]]]<>" *) \n \n \n"];

WriteString[out,"NameProcess = \""<>type<>name<>"\"; \n"];
WriteString[out,"FermionOrderExternal = "<>ToString[order]<>"; \n"];
WriteString[out,"ConsideredProcess = \""<>ToString[process]<>"\"; \n"];
WriteString[out,"NeglectMasses = "<>ToString[neglect]<>"; \n"];
WriteString[out,"ExternalFields = "<>ToString[fields]<>"; \n"];
WriteString[out,"ColorFlow = "<>ToString[color]<>"; \n"];
WriteString[out,"CombinationGenerations = "<>ToString[combis]<>"; \n\n\n"];
WriteString[out,"NeglectCrossedDiagrams = "<>ToString[crossed]<>"; \n\n\n"];
Switch[type,
"PengV", pre="PV"; nameop="VectorPenguinOperators";,
"PengS", pre="PS"; nameop="ScalarPenguinOperators";,
"TreeV", pre="TV"; nameop="VectorTreeOperators";,
"TreeS", pre="TS"; nameop="ScalarTreeOperators";,
"Box", pre="B"; nameop="BoxOperators";
];

WriteString[out,nameop<>" = { \n"];
For[i=1,i<=Length[ops],
WriteString[out,"{"<>pre<>ToString[ops[[i,1]]]<>", "<>StringReplace[ToString[ops[[i,2]]],{" "->""}]<>"}"];
If[i<Length[ops],WriteString[out,", \n"];];
i++;];
WriteString[out,"}; \n\n"];

WriteString[out,"OutputDir = \""<>name<>"\"; \n"];
WriteString[out,"OutputFile = \""<>name<>"_"<>type<>".m"<>"\"; \n\n\n"];

Close[out];
];


GetCodeForSARAHfromDirectory[dir_]:=Block[{iii,temp},
listfiles=FileNames["*.m",ToFileName[{$preSARAHdir,"Input",dir}],1];
For[iii=1,iii<=Length[listfiles],
temp=StringSplit[listfiles[[iii]],"/"][[-1]];
Print["Loading file ",temp];
GetOperators[ToFileName[{dir},temp]];
iii++;
];
];

GetOperators[file_]:=Block[{},
Clear[VectorPenguinOperators,ScalarPenguinOperators,BoxOperators, VectorTreeOperators, ScalarTreeOperators, VectorWaveOperators,ScalarWaveOperators];
ClearProcess[];

NeglectTopologiesWave={};
NeglectTopologiesPenguin={3};
NeglectTopologiesBox={};
NeglectTopologiesPhoton={};
NeglectTopologiesTree={};
NeglectCrossedDiagrams = False;

PS`DimensionsLoop=D;


Get[ToFileName[{$preSARAHdir,"Input"},file]];
Print["Initializing process"];
InitProcess;

Switch[ConsideredProcess,
"4Fermion",
   Run4FermionProcess;,
"2Fermion1Scalar",
  Run2Fermion1ScalarProcess;,
"2Fermion1Vector",
  Run2Fermion1ScalarProcess;
];



Print["-------------------------------------- "];
Print["Writing SARAH file "];
Print["-------------------------------------- "];
WriteSARAHFiles;
Print["Finished!"];
];

Run2Fermion1ScalarProcess:=Block[{},
Print["-------------------------------------- "];
Print["Calculating tree diagram "];
Print["-------------------------------------- "];
TreeAmplitudes=CalculateAllTree2Fermion; 
Print["-------------------------------------- "];
Print["Calculating all triangle diagrams "];
Print["-------------------------------------- "];
PenguinAmplitudes=CalculateAllPenguins2Fermion; 

Print["-------------------------------------- "];
Print["Calculating all wave diagrams "];
Print["-------------------------------------- "];
WaveAmplitudes=CalculateAllWave2Fermion;
];

Run4FermionProcess:=Block[{},
If[AddBoxes,
 Print["-------------------------------------- "];
Print["Calculating all box diagrams "];
Print["-------------------------------------- "];
 BoxAmplitudes=CalculateAllBoxes; 
];

If[AddScalars||AddVectors,
Print["-------------------------------------- "];
Print["Calculating all penguins diagrams "];
Print["-------------------------------------- "];
 PenguinAmplitudes=CalculateAllPenguins; 
];

If[AddScalars||AddVectors,
Print["-------------------------------------- "];
Print["Calculating all wave diagrams "];
Print["-------------------------------------- "];
WaveAmplitudes=CalculateAllWave;
];

If[AddScalarsTree||AddVectorsTree,
Print["-------------------------------------- "];
Print["Calculating all tree diagrams "];
Print["-------------------------------------- "];
TreeAmplitudes=CalculateAllTree;
];

];



CombinePhotonDiagrams:=Block[{i,j},
(* The Photon diagrams are numerically a bit delicate *)
(* Therefore, we sum up here the wave and the two possible penguin diagrams and simplify them analytically *)

(* The electric charges are choosen as follows:  *)
(*     - external Fermion: Qex   *)
(*     - internal Fermion: QF   *)
(*     - internal Scalar: QS   *)
(*     - internal Vector: QV   *)

(* In addition, we know that Photon vertices can't change the nature of the particle, i.e. we have just two unknown masses in the Penguin diagrams *)


PhotonSumScalar=Table[{},{Length[PhotonPenguinOperators]}];
PhotonSumVector=Table[{},{Length[PhotonPenguinOperators]}];

For[i=1,i<=Length[PhotonPenguinOperators],
PhotonSumScalar[[i]]={{PhotonPenguinOperators[[i,1]],(PenguinAmplitudes[[3,1,1,2,i,2]] /. {coup3L->QF,coup3R->QF,mF22->mF12,mF2->mF1})+(PenguinAmplitudes[[3,1,2,2,i,2]]/. {coup3->QS,mS22->mS12,mS2->mS1})+(WaveAmplitudes[[3,1,1,2,i,2]] /. {coup1L->Qex,coup1R->Qex,coup2L->coup1R,coup2R->coup1L,coup3L->coup2R,coup3R->coup2L, MFin->MassB, MFin2->MassB2}) //.{ vertexC12aux->vertexC12Ev, vertexC11aux->vertexC11Ev, vertexC0tildeaux->vertexC0tildeEv, C0[0,0,0,a_,b_,c_]->C03mEv[a,b,c],bb0[0,a_,b_]:>B0Ev[a,b],bb1[0,a_,b_]:>B1Ev[a,b]}}};
PhotonSumVector[[i]]={{PhotonPenguinOperators[[i,1]],(PenguinAmplitudes[[3,1,3,2,i,2]] /. {coup3L->QF,coup3R->QF,mF22->mF12,mF2->mF1})+(PenguinAmplitudes[[3,1,6,2,i,2]]/. {coup3->QV,mV22->mV12,mV2->mV1})+(WaveAmplitudes[[3,1,2,2,i,2]] /. {coup1L->Qex,coup1R->Qex,coup2L->coup1L,coup2R->coup1R,coup3L->coup2L,coup3R->coup2R, MFin->MassB, MFin2->MassB2}) //.{ vertexC12aux->vertexC12Ev, vertexC11aux->vertexC11Ev, vertexC0tildeaux->vertexC0tildeEv,C0[0,0,0,a_,b_,c_]->C03mEv[a,b,c],bb0[0,a_,b_]:>B0Ev[a,b],bb1[0,a_,b_]:>B1Ev[a,b]}}};
i++;];
];

vertexC12Ev[a_,b_,b_]:=-(3 a^2-4 a*b+b^2- a^2*Log[a/b])/(4*(a-b)^3);
vertexC12Ev[a_,a_,b_]:=vertexC12Ev[b,a,a];

vertexC11Ev[a_,b_,b_]:=-(3*a^2-4*a b+b^2-2*a^2*Log[a/b])/(2*(a-b)^3);
vertexC11Ev[a_,a_,b_]:=vertexC11Ev[b,a,a];

C03mEv[m1_,m2_,m2_]:=(1-m1/(m2-m1)*Log[m2/m1])/(m1-m2);
C03mEv[m2_,m2_,m1_]:=C03mEv[m1,m2,m2];
vertexC0tildeEv[m1_,m2_,m2_]:=(m1*(m1-m2)-m1^2 Log[m1]+(2 m1-m2) m2 Log[m2])/(m1-m2)^2 + 1/2;
vertexC0tildeEv[a_,a_,b_]:=vertexC0tildeEv[b,a,a];
B1Ev[m1_,m2_]:=-1/2 + 1/2 Log[m2] - (m1^2 - m2^2 +2 m1^2 Log[m2/m1])/(4(m1 - m2)^2); 
B0Ev[m1_,m1_]:=- Log[m1] ;
B0Ev[m1_,m2_]:=- Log[m2] + (m2 - m1 + m1 Log[m1/m2])/((m2 - m1)) /; (m1=!=m2);  

WriteSARAHFiles:=Block[{i,j,k},
Switch[ConsideredProcess,
"4Fermion",
out=OpenWrite[ToFileName[{$preSARAHdir,"Output",OutputDir},OutputFile]];
If[PS`MathematicaOut,outMath=OpenWrite[ToFileName[{$preSARAHdir,"Output",OutputDir},"math_"<>OutputFile]];];
  WriteWrapperCodeSARAH;
  If[AddBoxes,WriteBoxAmplitudes[BoxAmplitudes,NameProcess];];
  If[AddScalars||AddVectors,WritePenguinAmplitudes[PenguinAmplitudes,NameProcess]; ];
  If[AddScalars||AddVectors,WriteWaveAmplitudes[WaveAmplitudes,NameProcess];];
  If[AddScalarsTree||AddVectorsTree,WriteTreeAmplitudes[TreeAmplitudes,NameProcess];];,
"2Fermion1Scalar" | "2Fermion1Vector",
out=OpenWrite[ToFileName[{$preSARAHdir,"Output"},OutputFile]];
  WriteWrapperCodeSARAH2F;
 WriteTreeAmplitudes2F[{TreeAmplitudes},NameProcess]; 
  WritePenguinAmplitudes2F[{PenguinAmplitudes},NameProcess]; 
  WriteWaveAmplitudes2F[{WaveAmplitudes},NameProcess];
];
Close[out];
If[PS`MathematicaOut,Close[outMath];];
];

(*
StringReplaceForSARAH={"cc0["->"C0(","bb0"->"B0","bb1"->"B1","dd0["->"D0_Bagger(","dd00["->"D27_Bagger(","cc00["->"Cget(\\\"C00 \\\",","cc1["->"Cget(\\\"C1 \\\",","cc12["->"Cget(\\\"C12 \\\",","cc22["->"Cget(\\\"C22 \\\",","cc2["->"Cget(\\\"C2 \\\",","["->"(","]"->")","0.,"->"0._dp,"}; *)

StringReplaceForSARAH={"cc0["->"C0(","C003m["->"C00_3m(","C03m["->"C0check(","bb0"->"B0","bb1"->"B1","dd0["->"D0check(","dd00["->"D00check(","cc00["->"Cget(\\\"C00 \\\",","cc1["->"Cget(\\\"C1  \\\",","cc12["->"Cget(\\\"C12 \\\",","cc22["->"Cget(\\\"C22 \\\",","cc2["->"Cget(\\\"C2  \\\",","["->"(","]"->")","0.,"->"0._dp,"};
StringReplaceForMathematica={"cc0"->"C0","bb0"->"B0","bb1"->"B1","dd0"->"D0","dd00"->"D00","cc00"->"C0","cc1"->"C1","cc12"->"C12","cc22"->"C22","cc2"->"C2"};


StringReplaceForTeX={"cc0["->"C_0(","C003m["->"C_{00}(","C03m["->"C_0(","bb0"->"B_0","bb1"->"B_1","dd0["->"D_0(","dd00["->"D_{27}(","cc00["->"C_{00}(","cc1["->"C_1(","cc12["->"C_{12}(","cc22["->"C_{22}(","cc2["->"C_2(","["->"(","]"->")","int1"->"I_1","int2"->"I_2","int3"->"I_3","int4"->"I_4","int5"->"I_5","int6"->"I_6","int7"->"I_7","int8"->"I_8","int9"->"I_9","Finite"->"1","*"->" ","vertexC11aux"->"\\\\tilde{C}_{11}","vertexC12aux"->"\\\\tilde{C}_{12}"};





WriteBoxAmplitudes[amp_,name_]:=Block[{i,j,k,integrals,ii,subint},
WriteString[out,"AddBoxResultPreSARAH["<>name<>"][top_,type_,file_]:=Block[{}, \n"];
If[PS`MathematicaOut,WriteString[outMath,"BoxResultPreSARAH["<>name<>"][top_,type_]:=Block[{}, \n"];];
WriteString[out,"\n (* This routine returns the generic expression for the amplitude of a given box diagram *) \n \n"];
WriteString[out,"Switch[top, (* check in which order the external legs are glued to the box *) \n"];
If[PS`MathematicaOut,WriteString[outMath,"Switch[top, (* check in which order the external legs are glued to the box *) \n"];];
For[i=1,i<=3,
WriteString[out,ToString[i]<>", \n"];
If[PS`MathematicaOut,WriteString[outMath,ToString[i]<>", \n"];];
WriteString[out,"   Switch[type, (* Check the generic type of the diagram *) \n"];
If[PS`MathematicaOut,WriteString[outMath,"   Switch[type, (* Check the generic type of the diagram *) \n"];];
For[j=1,j<=Length[amp[[i]]],
WriteString[out,"\t"<>MakeTypeName[amp[[i,j,1]]]<>", \n"];
If[PS`MathematicaOut,WriteString[outMath,"\t"<>MakeTypeName[amp[[i,j,1]]]<>", \n"];];
integrals=Intersection[Select[Flatten[Transpose[amp[[i,j,2]]][[2]] /. Plus->List /.Times->List],(FreeQ[{bb0,bb1,cc0,C0,cc00,cc1,cc2,cc12,cc22,bb1,dd0,dd00,vertexC0tildeaux,vertexC12aux,vertexC11aux,C003m,C03m,C0m,C00m,C1m,C2m,C12m,C11m,C22m,C0D0check,B0C0check,MMD0,C1C12C11,C2C12C22,C1C2,C0C1C2,C12C11C2,C12C22C1,C1g,C2g,C11g,C12g,C22g},Head[#]]==False)&,99]];
subint=Flatten[Table[{(integrals[[ii]]/. {a_, {d1_,d2_,d3_},c_}->(a+d1 d2 d3+c))->ToExpression["int"<>ToString[ii]]},{ii,1,Length[integrals]}]];
For[ii=1,ii<=Length[integrals],
WriteString[out,"\t \t WriteString[file,\"  "<>"int"<>ToString[ii]<>"="<>StringReplace[ToString[N[integrals[[ii]]/. {a_, {d1_,d2_,d3_},c_}->(a+d1 d2 d3+c)]],StringReplaceForSARAH]<>"\\n\" ];\n"];
If[PS`MathematicaOut,WriteString[outMath,"\t \t int"<>ToString[ii]<>"="<>StringReplace[ToString[integrals[[ii]]/. {a_, {d1_,d2_,d3_},c_}->(a+d1 d2 d3+c)],StringReplaceForMathematica]<>";\n"];];
WriteString[out,"\t \t WriteString[sphenoTeX,\"I_"<>ToString[ii]<>" = & \"<> StringReplace[\""<>StringReplace[ToString[integrals[[ii]]/. {a_, {d1_,d2_,d3_},c_}->(a+d1 d2 d3+c)],StringReplaceForTeX]<>"\",SA`SPhenoTeXSub]<>\" \\\\\\\\ \\n\"];\n"];
ii++;];
For[k=1,k<=Length[amp[[i,j,2]]],
WriteString[out,"\t \t WriteStringFLB[file,\"  "<>ToString[amp[[i,j,2,k,1]]]<>"="<>ToString[amp[[i,j,2,k,1]]]<>"+"<>StringReplace[ToString[InputForm[N[chargefactor*Simplify[amp[[i,j,2,k,2]]/.subint]]]],StringReplaceForSARAH]<>"\\n\" ];\n"];
If[PS`MathematicaOut,WriteString[outMath,"\t \t "<>ToString[amp[[i,j,2,k,1]]]<>"="<>StringReplace[ToString[InputForm[chargefactor*Simplify[amp[[i,j,2,k,2]]/.subint]]],StringReplaceForMathematica]<>";\n"];];
WriteString[out,"\t \t WriteString[sphenoTeX,\"  "<>StringReplace[ToString[amp[[i,j,2,k,1]]],TeXNames]<>"= & \"<> StringReplace[\""<>StringReplace[ToString[InputForm[chargefactor*Simplify[amp[[i,j,2,k,2]]/.subint]]],StringReplaceForTeX]<>"\",SA`SPhenoTeXSub] <>\" \\\\\\\\ \\n\" ];\n"];
k++;];
If[j<Length[amp[[i]]],
WriteString[out,",\n"];
If[PS`MathematicaOut,WriteString[outMath,",\n"];];
];
j++;];
WriteString[out,"];"];
If[PS`MathematicaOut,WriteString[outMath,"];"];];
If[i<3,WriteString[out,",\n"];
If[PS`MathematicaOut,WriteString[outMath,",\n"]];];
i++;];
WriteString[out,"]; \n"];
If[PS`MathematicaOut,WriteString[outMath,"]; \n"];];
WriteString[out,"]; \n\n\n"];
If[PS`MathematicaOut,WriteString[outMath,"]; \n\n\n"];];
];

WriteTreeAmplitudes[amp_,name_]:=Block[{i,j,k,l,integrals,ii,subint},
WriteString[out,"AddTreeResultPreSARAH["<>name<>"][prop_,top_,type_,file_]:=Block[{}, \n"];
If[PS`MathematicaOut,WriteString[outMath,"AddTreeResultPreSARAH["<>name<>"][prop_,top_,type_]:=Block[{}, \n"];];
WriteString[out,"\n (* This routine returns the generic expression for the amplitude of a given triangle diagram *) \n \n"];
WriteString[out,"Switch[prop,\n"];
If[PS`MathematicaOut,WriteString[outMath,"Switch[prop,\n"];];
For[i=1,i<=2,
Switch[i,
1,
WriteString[out,"V, (* Vector penguins *) \n"];
If[PS`MathematicaOut,WriteString[outMath,"V, (* Vector penguins *) \n"];];,
2,
WriteString[out,"S, (* Scalar penguins *) \n"];
If[PS`MathematicaOut,WriteString[outMath,"S, (* Scalar penguins *) \n"];];,
3,
WriteString[out,"P, (* Photon penguins *) \n"];
If[PS`MathematicaOut,WriteString[outMath,"P, (* Photon penguins *) \n"];];
];
If[i==1 && AddVectorsTree || i==2 && AddScalarsTree,
WriteString[out," Switch[top,  (* Check topology *) \n"];
If[PS`MathematicaOut,WriteString[outMath," Switch[top,  (* Check topology *) \n"];];
For[l=1,l<=3,
WriteString[out,"  "<>ToString[l]<>", \n"];
If[PS`MathematicaOut,WriteString[outMath,"  "<>ToString[l]<>", \n"];];
For[j=1,j<=Length[amp[[i,l]]],
For[k=1,k<=Length[amp[[i,l,j,2]]],
WriteString[out,"\t \t WriteStringFLB[file,\"  "<>ToString[amp[[i,l,j,2,k,1]]]<>"="<>ToString[amp[[i,l,j,2,k,1]]]<>"+ "<>StringReplace[ToString[InputForm[N[Simplify[amp[[i,l,j,2,k,2]]]]]],StringReplaceForSARAH]<>"\\n\" ];\n"];
If[PS`MathematicaOut,WriteString[outMath,"\t \t "<>ToString[amp[[i,l,j,2,k,1]]]<>"="<>StringReplace[ToString[InputForm[Simplify[amp[[i,l,j,2,k,2]]]]],StringReplaceForMathematica]<>";\n"];];
WriteString[out,"\t \t WriteString[sphenoTeX,\"  "<>StringReplace[ToString[amp[[i,l,j,2,k,1]]],TeXNames]<>"= & \"<> StringReplace[\""<>StringReplace[ToString[InputForm[Simplify[amp[[i,l,j,2,k,2]]]]],StringReplaceForTeX]<>"\",SA`SPhenoTeXSub]<>\" \\\\\\\\ \\n\" ];\n"];
k++;];
If[j<Length[amp[[i,1]]],
WriteString[out,",\n"];
If[PS`MathematicaOut,WriteString[outMath,",\n"];];
];
j++;];
If[l<3,
WriteString[out,",\n"];
If[PS`MathematicaOut,WriteString[outMath,",\n"];];
];
l++;];
WriteString[out,"];"]; (* end top *)
If[PS`MathematicaOut,WriteString[outMath,"];"]; (* end top *)];,
WriteString[out, "Return[]; (* not necessary *) "];
If[PS`MathematicaOut,WriteString[outMath, "Return[]; (* not necessary *) "];];
];
If[i<2,
WriteString[out,",\n"];
If[PS`MathematicaOut,WriteString[outMath,",\n"];];
];
i++;];
WriteString[out,"]; \n"]; (* end type *)
If[PS`MathematicaOut,WriteString[outMath,"]; \n"]; (* end type *)];
WriteString[out,"]; \n\n\n"]; (* end routine *)
If[PS`MathematicaOut,WriteString[outMath,"]; \n\n\n"]; (* end routine *)];
];

WriteTreeAmplitudes2F[amp_,name_]:=Block[{i,j,k,l,integrals,ii,subint},
WriteString[out,"AddTreeResultPreSARAH["<>name<>"][top_,type_,file_]:=Block[{}, \n"];
WriteString[out,"\n (* This routine returns the generic expression for the amplitude of a given triangle diagram *) \n \n"];
WriteString[out," Switch[top,  (* Check topology *) \n"];
i=1;
For[l=1,l<=1,
WriteString[out,"  "<>ToString[l]<>", \n"];
For[j=1,j<=Length[amp[[i,l]]],
For[k=1,k<=Length[amp[[i,l,j,2]]],
WriteString[out,"\t \t WriteStringFLB[file,\"  "<>ToString[amp[[i,l,j,2,k,1]]]<>"="<>ToString[amp[[i,l,j,2,k,1]]]<>"+ "<>StringReplace[ToString[InputForm[N[Simplify[amp[[i,l,j,2,k,2]]]]]],StringReplaceForSARAH]<>"\\n\" ];\n"];
WriteString[out,"\t \t WriteString[sphenoTeX,\"  "<>StringReplace[ToString[amp[[i,l,j,2,k,1]]],TeXNames]<>"= & \"<> StringReplace[\""<>StringReplace[ToString[InputForm[Simplify[amp[[i,l,j,2,k,2]]]]],StringReplaceForTeX]<>"\",SA`SPhenoTeXSub]<>\" \\\\\\\\ \\n\" ];\n"];
k++;];
If[j<Length[amp[[i,1]]],WriteString[out,",\n"]];
j++;];
l++;];
WriteString[out,"]; \n"]; (* end type *)
WriteString[out,"]; \n\n\n"]; (* end routine *)
];

WritePenguinAmplitudes[amp_,name_]:=Block[{i,j,k,l,integrals,ii,subint},
WriteString[out,"AddPenguinResultPreSARAH["<>name<>"][prop_,top_,type_,file_]:=Block[{}, \n"];
If[PS`MathematicaOut,WriteString[outMath,"AddPenguinResultPreSARAH["<>name<>"][prop_,top_,type_]:=Block[{}, \n"];];
WriteString[out,"\n (* This routine returns the generic expression for the amplitude of a given triangle diagram *) \n \n"];
WriteString[out,"Switch[prop,\n"];
If[PS`MathematicaOut,WriteString[outMath,"Switch[prop,\n"];];
For[i=1,i<=2,
Switch[i,
1,
WriteString[out,"V, (* Vector penguins *) \n"];
If[PS`MathematicaOut,WriteString[outMath,"V, (* Vector penguins *) \n"];];,
2,
WriteString[out,"S, (* Scalar penguins *) \n"];
If[PS`MathematicaOut,WriteString[outMath,"S, (* Scalar penguins *) \n"];];,
3,
WriteString[out,"P, (* Photon penguins *) \n"];
If[PS`MathematicaOut,WriteString[outMath,"P, (* Photon penguins *) \n"];];
];
If[i==1 && AddVectors || i==2 && AddScalars,
WriteString[out," Switch[top,  (* Check topology *) \n"];
If[PS`MathematicaOut,WriteString[outMath," Switch[top,  (* Check topology *) \n"];];
For[l=1,l<=6,
WriteString[out,"  "<>ToString[l]<>", \n"];
If[PS`MathematicaOut,WriteString[outMath,"  "<>ToString[l]<>", \n"];];
WriteString[out,"  Switch[type,  (* Check the generic type of the diagram *) \n"];
If[PS`MathematicaOut,WriteString[outMath,"  Switch[type,  (* Check the generic type of the diagram *) \n"];];
For[j=1,j<=Length[amp[[i,l]]],
WriteString[out,"\t"<>MakeTypeName[amp[[i,l,j,1]]]<>", \n"];
If[PS`MathematicaOut,WriteString[outMath,"\t"<>MakeTypeName[amp[[i,l,j,1]]]<>", \n"];];
integrals=Intersection[Select[Flatten[Transpose[amp[[i,l,j,2]]][[2]] /. Plus->List /.Times->List],(FreeQ[{bb0,cc0,cc00,C0,cc1,cc2,cc12,cc22,bb1,dd0,dd00,vertexC0tildeaux,vertexC12aux,vertexC11aux,C003m,C03m,C0D0check,B0C0check,MMD0},Head[#]]==False)&,99]];
subint=Flatten[Table[{(integrals[[ii]]/. {a_, {d1_,d2_,d3_},c_}->(a+d1 d2 d3+c))->ToExpression["int"<>ToString[ii]]},{ii,1,Length[integrals]}]];
For[ii=1,ii<=Length[integrals],
WriteString[out,"\t \t WriteString[file,\"  "<>"int"<>ToString[ii]<>"="<>StringReplace[ToString[N[integrals[[ii]]/. {a_, {d1_,d2_,d3_},c_}->(a+d1 d2 d3+c)]],StringReplaceForSARAH]<>"\\n\" ];\n"];
If[PS`MathematicaOut,WriteString[outMath,"\t \t int"<>ToString[ii]<>"="<>StringReplace[ToString[integrals[[ii]]/. {a_, {d1_,d2_,d3_},c_}->(a+d1 d2 d3+c)],StringReplaceForMathematica]<>";\n"];];
WriteString[out,"\t \t WriteString[sphenoTeX,\"I_"<>ToString[ii]<>"= & \"<> StringReplace[\""<>StringReplace[ToString[integrals[[ii]]/. {a_, {d1_,d2_,d3_},c_}->(a+d1 d2 d3+c)],StringReplaceForTeX]<>"\",SA`SPhenoTeXSub]<>\" \\\\\\\\ \\n\"];\n"];
ii++;];
For[k=1,k<=Length[amp[[i,l,j,2]]],
WriteString[out,"\t \t WriteStringFLB[file,\"  "<>ToString[amp[[i,l,j,2,k,1]]]<>"="<>ToString[amp[[i,l,j,2,k,1]]]<>"+"<>StringReplace[ToString[InputForm[N[chargefactor*Simplify[amp[[i,l,j,2,k,2]]/.subint]]]],StringReplaceForSARAH]<>"\\n\" ];\n"];
If[PS`MathematicaOut,WriteString[outMath,"\t \t "<>ToString[amp[[i,l,j,2,k,1]]]<>"="<>StringReplace[ToString[InputForm[chargefactor*Simplify[amp[[i,l,j,2,k,2]]/.subint]]],StringReplaceForMathematica]<>";\n"];];
WriteString[out,"\t \t WriteString[sphenoTeX,\"  "<>StringReplace[ToString[amp[[i,l,j,2,k,1]]],TeXNames]<>"= & \"<> StringReplace[\""<>StringReplace[ToString[InputForm[chargefactor*Simplify[amp[[i,l,j,2,k,2]]/.subint]]],StringReplaceForTeX]<>"\",SA`SPhenoTeXSub]<>\" \\\\\\\\ \\n\" ];\n"];
k++;];
If[j<Length[amp[[i,1]]],
WriteString[out,",\n"];
If[PS`MathematicaOut,WriteString[outMath,",\n"];];
];
j++;];
WriteString[out,"]; \n"]; (* end type *)
If[PS`MathematicaOut,WriteString[outMath,"]; \n"]; (* end type *)];
If[l<6,
WriteString[out,",\n"];
If[PS`MathematicaOut,WriteString[outMath,",\n"];];
];
l++;];
WriteString[out,"];"]; (* end top *)
If[PS`MathematicaOut,WriteString[outMath,"];"]; (* end top *)];,
WriteString[out, "Return[]; (* not necessary *) "];
If[PS`MathematicaOut,WriteString[outMath, "Return[]; (* not necessary *) "];];
];
If[i<2,
WriteString[out,",\n"];
If[PS`MathematicaOut,WriteString[outMath,",\n"];];
];
i++;];
WriteString[out,"]; \n"]; (* end type *)
If[PS`MathematicaOut,WriteString[outMath,"]; \n"]; (* end type *)];
WriteString[out,"]; \n\n\n"]; (* end routine *)
If[PS`MathematicaOut,WriteString[outMath,"]; \n\n\n"]; (* end routine *)];
];

WritePenguinAmplitudes2F[amp_,name_]:=Block[{i,j,k,l,integrals,ii,subint},
WriteString[out,"AddPenguinResultPreSARAH["<>name<>"][top_,type_,file_]:=Block[{}, \n"];
WriteString[out,"\n (* This routine returns the generic expression for the amplitude of a given triangle diagram *) \n \n"];
WriteString[out," Switch[top,  (* Check topology *) \n"];
i=1;
For[l=1,l<=1,
WriteString[out,"  "<>ToString[l]<>", \n"];
WriteString[out,"  Switch[type,  (* Check the generic type of the diagram *) \n"];
For[j=1,j<=Length[amp[[i,l]]],
WriteString[out,"\t"<>MakeTypeName[amp[[i,l,j,1]]]<>", \n"];
integrals=Intersection[Select[Flatten[Transpose[amp[[i,l,j,2]]][[2]] /. Plus->List /.Times->List],(FreeQ[{bb0,cc0,cc00,C0,cc1,cc2,cc12,cc22,bb1,dd0,dd00,C0m,C00m,C1m,C2m,C12m,C11m,C22m,vertexC0tildeaux,vertexC12aux,vertexC11aux,C003m,C03m,C0D0check,B0C0check,MMD0,C1C12C11,C2C12C22,C1C2,C0C1C2,C12C11C2,C12C22C1,C12C22,C2C12,C0g,C00g,C1g,C2g,C12g,C11g,C22g},Head[#]]==False)&,99]];
subint=Flatten[Table[{(integrals[[ii]]/. {a_, {d1_,d2_,d3_},c_}->(a+d1 d2 d3+c))->ToExpression["int"<>ToString[ii]]},{ii,1,Length[integrals]}]];
For[ii=1,ii<=Length[integrals],
WriteString[out,"\t \t WriteString[file,\"  "<>"int"<>ToString[ii]<>"="<>StringReplace[ToString[N[integrals[[ii]]/. {a_, {d1_,d2_,d3_},c_}->(a+d1 d2 d3+c)]],StringReplaceForSARAH]<>"\\n\" ];\n"];
WriteString[out,"\t \t WriteString[sphenoTeX,\"I_"<>ToString[ii]<>"= & \"<> StringReplace[\""<>StringReplace[ToString[integrals[[ii]]/. {a_, {d1_,d2_,d3_},c_}->(a+d1 d2 d3+c)],StringReplaceForTeX]<>"\",SA`SPhenoTeXSub]<>\" \\\\\\\\ \\n\"];\n"];
ii++;];
For[k=1,k<=Length[amp[[i,l,j,2]]],
WriteString[out,"\t \t WriteStringFLB[file,\"  "<>ToString[amp[[i,l,j,2,k,1]]]<>"="<>ToString[amp[[i,l,j,2,k,1]]]<>"+"<>StringReplace[ToString[InputForm[N[chargefactor*Simplify[amp[[i,l,j,2,k,2]]/.subint]]]],StringReplaceForSARAH]<>"\\n\" ];\n"];
WriteString[out,"\t \t WriteString[sphenoTeX,\"  "<>StringReplace[ToString[amp[[i,l,j,2,k,1]]],TeXNames]<>"= & \"<> StringReplace[\""<>StringReplace[ToString[InputForm[chargefactor*Simplify[amp[[i,l,j,2,k,2]]/.subint]]],StringReplaceForTeX]<>"\",SA`SPhenoTeXSub]<>\" \\\\\\\\ \\n\" ];\n"];
k++;];
If[j<Length[amp[[i,1]]],WriteString[out,",\n"]];
j++;];
WriteString[out,"]; \n"]; (* end type *)
If[l<1,WriteString[out,",\n"]];
l++;];
WriteString[out,"];"]; (* end top *)
WriteString[out,"]; \n\n\n"]; (* end routine *)
];

WriteWaveAmplitudes[amp_,name_]:=Block[{i,j,k,l,integrals,ii,subint},
WriteString[out,"AddWaveResultPreSARAH["<>name<>"][prop_,top_,type_,file_]:=Block[{}, \n"];
If[PS`MathematicaOut,WriteString[outMath,"AddWaveResultPreSARAH["<>name<>"][prop_,top_,type_]:=Block[{}, \n"];];
WriteString[out,"\n (* This routine returns the generic expression for the amplitude of a given triangle diagram *) \n \n"];
WriteString[out,"Switch[prop,\n"];
If[PS`MathematicaOut,WriteString[outMath,"Switch[prop,\n"];];
For[i=1,i<=2,
Switch[i,
1,WriteString[out,"V, (* Vector penguins *) \n"];
       If[PS`MathematicaOut,WriteString[outMath,"V, (* Vector penguins *) \n"];];,
2,WriteString[out,"S, (* Scalar penguins *) \n"];
      If[PS`MathematicaOut,WriteString[outMath,"S, (* Scalar penguins *) \n"];];,
3,WriteString[out,"P, (* Photon penguins *) \n"];
      If[PS`MathematicaOut,WriteString[outMath,"P, (* Photon penguins *) \n"];];
];
If[i==1 && AddVectors || i==2 && AddScalars,
WriteString[out," Switch[top,  (* Check topology *) \n"];
If[PS`MathematicaOut,WriteString[outMath," Switch[top,  (* Check topology *) \n"];];
For[l=1,l<=12,
WriteString[out,"  "<>Switch[l,5,"6",6,"5",_,ToString[l]]<>", \n"];
If[PS`MathematicaOut,WriteString[outMath,"  "<>Switch[l,5,"6",6,"5",_,ToString[l]]<>", \n"];];
WriteString[out,"  Switch[type,  (* Check the generic type of the diagram *) \n"];
If[PS`MathematicaOut,WriteString[outMath,"  Switch[type,  (* Check the generic type of the diagram *) \n"];];
For[j=1,j<=Length[amp[[i,l]]],
WriteString[out,"\t"<>MakeTypeName[amp[[i,l,j,1]]]<>" | "<> MakeTypeName[{amp[[i,l,j,1,2]],amp[[i,l,j,1,1]]}]<>" , \n"];
If[PS`MathematicaOut,WriteString[outMath,"\t"<>MakeTypeName[amp[[i,l,j,1]]]<>" | "<> MakeTypeName[{amp[[i,l,j,1,2]],amp[[i,l,j,1,1]]}]<>" , \n"];];
integrals=Intersection[Select[Flatten[Transpose[amp[[i,l,j,2]]][[2]] /. Plus->List /.Times->List],(FreeQ[{bb0,cc0,cc00,C0,cc1,cc2,cc12,cc22,bb1,dd0,dd00,vertexC0tildeaux,vertexC12aux,vertexC11aux,C003m,C03m,C0D0check,B0C0check,MMD0},Head[#]]==False)&,99]];
subint=Flatten[Table[{(integrals[[ii]]/. {a_, {d1_,d2_,d3_},c_}->(a+d1 d2 d3+c))->ToExpression["int"<>ToString[ii]]},{ii,1,Length[integrals]}]];
For[ii=1,ii<=Length[integrals],
WriteString[out,"\t \t WriteString[file,\"  "<>"int"<>ToString[ii]<>"="<>StringReplace[ToString[N[integrals[[ii]]/. {a_, {d1_,d2_,d3_},c_}->(a+d1 d2 d3+c)]],StringReplaceForSARAH]<>"\\n\" ];\n"];
If[PS`MathematicaOut,WriteString[outMath,"\t \t int"<>ToString[ii]<>"="<>StringReplace[ToString[integrals[[ii]]/. {a_, {d1_,d2_,d3_},c_}->(a+d1 d2 d3+c)],StringReplaceForMathematica]<>";\n"];];
WriteString[out,"\t \t WriteString[sphenoTeX,\"I_"<>ToString[ii]<>"= & \"<> StringReplace[\""<>StringReplace[ToString[integrals[[ii]]/. {a_, {d1_,d2_,d3_},c_}->(a+d1 d2 d3+c)],StringReplaceForTeX]<>"\",SA`SPhenoTeXSub]<>\" \\\\\\\\ \\n\"];\n"];
ii++;];
For[k=1,k<=Length[amp[[i,l,j,2]]],
WriteString[out,"\t \t WriteStringFLB[file,\"  "<>ToString[amp[[i,l,j,2,k,1]]]<>"="<>ToString[amp[[i,l,j,2,k,1]]]<>"+"<>StringReplace[ToString[InputForm[N[chargefactor*Simplify[amp[[i,l,j,2,k,2]]/.subint]]]],StringReplaceForSARAH]<>"\\n\" ];\n"];
If[PS`MathematicaOut,WriteString[outMath,"\t \t "<>ToString[amp[[i,l,j,2,k,1]]]<>"="<>StringReplace[ToString[InputForm[chargefactor*Simplify[amp[[i,l,j,2,k,2]]/.subint]]],StringReplaceForMathematica]<>";\n"];];
WriteString[out,"\t \t WriteString[sphenoTeX,\"  "<>StringReplace[ToString[amp[[i,l,j,2,k,1]]],TeXNames]<>"= & \"<> StringReplace[\""<>StringReplace[ToString[InputForm[chargefactor*Simplify[amp[[i,l,j,2,k,2]]/.subint]]],StringReplaceForTeX]<>"\",SA`SPhenoTeXSub]<>\" \\\\\\\\ \\n\" ];\n"];
k++;];
If[j<Length[amp[[i,1]]],
WriteString[out,",\n"];
If[PS`MathematicaOut,WriteString[outMath,",\n"];];
];
j++;];
WriteString[out,"]; \n"]; (* end type *)
If[PS`MathematicaOut,WriteString[outMath,"]; \n"]; (* end type *)];
If[l<12,
WriteString[out,",\n"];
If[PS`MathematicaOut,WriteString[outMath,",\n"];];
];
l++;];
WriteString[out,"];"]; (* end top *)
If[PS`MathematicaOut,WriteString[outMath,"];"]; (* end top *)];,
WriteString[out,"Return[]; (* not necessary *) "];
If[PS`MathematicaOut,WriteString[outMath,"Return[]; (* not necessary *) "];];
];
If[i<2,
WriteString[out,",\n"];
If[PS`MathematicaOut,WriteString[outMath,",\n"];];
];
i++;];
WriteString[out,"]; \n"]; (* end type *)
If[PS`MathematicaOut,WriteString[outMath,"]; \n"]; (* end type *)];
WriteString[out,"]; \n\n\n"]; (* end routine *)
If[PS`MathematicaOut,WriteString[outMath,"]; \n\n\n"]; (* end routine *)];
];

WriteWaveAmplitudes2F[amp_,name_]:=Block[{i,j,k,l,integrals,ii,subint},
WriteString[out,"AddWaveResultPreSARAH["<>name<>"][top_,type_,file_]:=Block[{}, \n"];
WriteString[out,"\n (* This routine returns the generic expression for the amplitude of a given triangle diagram *) \n \n"];
WriteString[out," Switch[top,  (* Check topology *) \n"];
i=1;
For[l=1,l<=2,
WriteString[out,"  "<>ToString[l]<>", \n"];
WriteString[out,"  Switch[type,  (* Check the generic type of the diagram *) \n"];
For[j=1,j<=Length[amp[[i,l]]],
WriteString[out,"\t"<>MakeTypeName[amp[[i,l,j,1]]]<>" | "<> MakeTypeName[{amp[[i,l,j,1,2]],amp[[i,l,j,1,1]]}]<>" , \n"];
integrals=Intersection[Select[Flatten[Transpose[amp[[i,l,j,2]]][[2]] /. Plus->List /.Times->List],(FreeQ[{bb0,cc0,cc00,C0,cc1,cc2,cc12,cc22,bb1,dd0,dd00,vertexC0tildeaux,vertexC12aux,vertexC11aux,C003m,C03m,C0D0check,B0C0check,MMD0},Head[#]]==False)&,99]];
subint=Flatten[Table[{(integrals[[ii]]/. {a_, {d1_,d2_,d3_},c_}->(a+d1 d2 d3+c))->ToExpression["int"<>ToString[ii]]},{ii,1,Length[integrals]}]];
For[ii=1,ii<=Length[integrals],
WriteString[out,"\t \t WriteString[file,\"  "<>"int"<>ToString[ii]<>"="<>StringReplace[ToString[N[integrals[[ii]]/. {a_, {d1_,d2_,d3_},c_}->(a+d1 d2 d3+c)]],StringReplaceForSARAH]<>"\\n\" ];\n"];
WriteString[out,"\t \t WriteString[sphenoTeX,\"I_"<>ToString[ii]<>"= & \"<> StringReplace[\""<>StringReplace[ToString[integrals[[ii]]/. {a_, {d1_,d2_,d3_},c_}->(a+d1 d2 d3+c)],StringReplaceForTeX]<>"\",SA`SPhenoTeXSub]<>\" \\\\\\\\ \\n\"];\n"];
ii++;];
For[k=1,k<=Length[amp[[i,l,j,2]]],
WriteString[out,"\t \t WriteStringFLB[file,\"  "<>ToString[amp[[i,l,j,2,k,1]]]<>"="<>ToString[amp[[i,l,j,2,k,1]]]<>"+"<>StringReplace[ToString[InputForm[N[chargefactor*Simplify[amp[[i,l,j,2,k,2]]/.subint]]]],StringReplaceForSARAH]<>"\\n\" ];\n"];
WriteString[out,"\t \t WriteString[sphenoTeX,\"  "<>StringReplace[ToString[amp[[i,l,j,2,k,1]]],TeXNames]<>"= & \"<> StringReplace[\""<>StringReplace[ToString[InputForm[chargefactor*Simplify[amp[[i,l,j,2,k,2]]/.subint]]],StringReplaceForTeX]<>"\",SA`SPhenoTeXSub]<>\" \\\\\\\\ \\n\" ];\n"];
k++;];
If[j<Length[amp[[i,1]]],WriteString[out,",\n"]];
j++;];
WriteString[out,"]; \n"]; (* end type *)
If[l<2,WriteString[out,",\n"]];
l++;];
WriteString[out,"];"]; (* end top *)
WriteString[out,"]; \n\n\n"]; (* end routine *)
];


MakeTypeName[list_]:=StringReplace[ToString[list],{","->"","{"->"","}"->""," "->""}];


WriteWrapperCodeSARAH:=Block[{i,j,k},
(* We are going to generate two wrapper functions for SARAH *)
(* 1) Checks for all possible diagrams, extracts the necessary masses and couplings *)
(* 2) Writes the Fortran Code using the information from 1) as well as the calculated amplitudes *)

(* Note, works so far only with processes with four external fermions *)

WriteString[out,"(* Code automatically generated by 'PreSARAH' *) \n"];
WriteString[out,"(* Expressions for amplitudes are obtained by FeynArts/FormCalc *) \n"];
WriteString[out,"(* This file is supposed to be loaded and used by SARAH *) \n"];
Minutes=If[Date[][[5]]<10,"0"<>ToString[Date[][[5]]],ToString[Date[][[5]]]];
WriteString[out,"(* Created at "<>ToString[Date[][[4]]]<>":"<>Minutes<>" on "<>ToString[Date[][[3]]]<>"."<>ToString[Date[][[2]]]<>"."<>ToString[Date[][[1]]]<>" *) \n \n \n"];

WriteString[out,"PrintDebug[\"   ... \"," <>NameProcess<>"]; \n"];

WriteString[out,"NamesParticles =  "<>ToString[ExternalFields]<>"; \n "];

If[AddVectors,
WriteString[out,"NamesOperators =  "<>ToString[Transpose[VectorPenguinOperators][[1]]]<>"; \n "];
];
If[AddVectorsTree,
WriteString[out,"NamesOperators =  "<>ToString[Transpose[VectorTreeOperators][[1]]]<>"; \n "];
];
If[AddScalars,
WriteString[out,"NamesOperators =  "<>ToString[Transpose[ScalarPenguinOperators][[1]]]<>"; \n "];
];
If[AddScalarsTree,
WriteString[out,"NamesOperators =  "<>ToString[Transpose[ScalarTreeOperators][[1]]]<>"; \n "];
];
If[AddBoxes,
WriteString[out,"NamesOperators =  "<>ToString[Transpose[BoxOperators][[1]]]<>"; \n "];
];


(* WriteString[out,"NeglectInsertionOrderPhoton["<>NameProcess<>"] = "<>ToString[NeglectTopologiesPhoton]<>"; \n"]; *)
If[AddScalars || AddVectors,
WriteString[out,"NeglectInsertionOrderWave["<>NameProcess<>"] =  "<>ToString[NeglectTopologiesWave]<>"; \n"];
WriteString[out,"NeglectInsertionOrderPenguin["<>NameProcess<>"] =  "<>ToString[NeglectTopologiesPenguin]<>"; \n"];
];
If[AddScalarsTree || AddVectorsTree,
WriteString[out,"NeglectInsertionOrderTree["<>NameProcess<>"] =  "<>ToString[NeglectTopologiesTree]<>"; \n"];
];
If[AddBoxes,
WriteString[out,"NeglectInsertionOrderBox["<>NameProcess<>"] = "<>ToString[NeglectTopologiesBox]<>"; \n"];
];

WriteString[out,"NeglectCrossedDiagrams["<>NameProcess<>"] = "<>ToString[NeglectCrossedDiagrams]<>"; \n"];


WriteString[out,"NameProcess = "<>NameProcess<>"; \n \n"];
If[Head[ColorFlow]=!=Symbol,
WriteString[out,"ColorFlow = "<>ToString[ColorFlow]<>"; \n \n"];
];

(* WriteString[out,"NameObservables = "<>ToString[NameObservables]<>"; \n \n"]; *)

WriteString[out,"Generate["<>NameProcess<>"][file_]:=Block[{i,j,k}, \n \n"];

WriteString[out,"\n (* Creating all possible processes; extract information about involved masses/couplings *) \n"];


WriteString[out,"\n\n(* ------------------------------- *)\n"];
WriteString[out,"(* "<>ToString[ExternalFields]<>" *)\n"];
WriteString[out,"(* ------------------------------- *)\n \n"];
WriteString[out,"GetInformtion4FermionProcess["<>ToString[ExternalFields[[1]]]<>","<>ToString[ExternalFields[[2]]]<>","<>ToString[ExternalFields[[3]]]<>","<>ToString[ExternalFields[[4]]]<>","<>NameProcess<>",file]; \n"];


WriteString[out,"NeededMassesAll=Intersection[NeededMasses];\n"];
WriteString[out,"NeededCouplingsAll=Intersection[NeededCouplings];\n"];


WriteString[out,"WriteCodeObservablePreSARAH["<>NameProcess<>"][NeededMassesAll,NeededCouplingsAll,TreeContributionsScalar,TreeContributionsVector,WaveContributionsScalar,WaveContributionsVector,WaveContributionsPhoton,PenguinContributionsScalar,PenguinContributionsVector,PenguinContributionsPhoton,BoxContributions,file]; \n"];

WriteString[out,"NeededMassAllSaved["<>NameProcess<>"] = masses \n"];

WriteString[out,"]; \n\n"];

WriteString[out,"WriteCodeObservablePreSARAH["<>NameProcess<>"][masses_,couplings_,treeScalar_,treeVector_,waveScalar_,waveVector_,wavePhoton_,penguinScalar_,penguinVector_,penguinPhoton_,box_,file_] :=Block[{i,j,k,fermions,scalars}, \n \n"];

WriteString[out,"NeededMassesAllSaved["<>NameProcess<>"] = masses; \n"];
WriteString[out,"NeededCouplingsAllSaved["<>NameProcess<>"] = couplings; \n"];
WriteString[out,"NeededCombinations["<>NameProcess<>"] = "<>ToString[CombinationGenerations]<>"; \n"];

WriteString[out,"PrintDebug[\"     writing SPheno code for \","<>NameProcess<>"]; \n"];

WriteString[out,"MakeSubroutineTitle[\"Calculate"<>NameProcess<>"\",Flatten[{masses,couplings}],"];

Switch[Length[ExternalFields],
1,WriteString[out,"{\"gt1\",\"OnlySM\"}, \n"];, 
2,WriteString[out,"{\"gt1\",\"gt2\",\"OnlySM\"}, \n"];, 
3,WriteString[out,"{\"gt1\",\"gt2\",\"gt3\",\"OnlySM\"}, \n"];,
4,WriteString[out,"{\"gt1\",\"gt2\",\"gt3\",\"gt4\",\"OnlySM\"}, \n"]; 
];

If[AddBoxes,
WriteString[out,ToString[Table["\""<>ToString[BoxOperators[[i,1]]]<>"\"",{i,1,Length[BoxOperators]}]]<>",file]; \n"]; 
];

If[AddScalars,
WriteString[out,ToString[Table["\""<>ToString[ScalarPenguinOperators[[i,1]]]<>"\"",{i,1,Length[ScalarPenguinOperators]}]]<>",file]; \n"]; 
];

If[AddVectors,
WriteString[out,ToString[Table["\""<>ToString[VectorPenguinOperators[[i,1]]]<>"\"",{i,1,Length[VectorPenguinOperators]}]]<>",file]; \n"]; 
];

If[AddScalarsTree,
WriteString[out,ToString[Table["\""<>ToString[ScalarTreeOperators[[i,1]]]<>"\"",{i,1,Length[ScalarTreeOperators]}]]<>",file]; \n"]; 
];

If[AddVectorsTree,
WriteString[out,ToString[Table["\""<>ToString[VectorTreeOperators[[i,1]]]<>"\"",{i,1,Length[VectorTreeOperators]}]]<>",file]; \n"]; 
];

WriteString[out,"WriteString[file,\"! ---------------------------------------------------------------- \\n\"]; \n"];
WriteString[out,"WriteString[file,\"! Code based on automatically generated SARAH extensions by 'PreSARAH' \\n\"]; \n"];
WriteString[out,"WriteString[file,\"! Expressions for amplitudes are obtained by FeynArts/FormCalc \\n\"]; \n"];
WriteString[out,"WriteString[file,\"! Based on user input for process "<>NameProcess<>" \\n\"]; \n"];
WriteString[out,"WriteString[file,\"! 'PreSARAH' output has been generated  at "<>ToString[Date[][[4]]]<>":"<>Minutes<>" on "<>ToString[Date[][[3]]]<>"."<>ToString[Date[][[2]]]<>"."<>ToString[Date[][[1]]]<>" \\n\"]; \n"];
WriteString[out,"WriteString[file,\"! ---------------------------------------------------------------- \\n \\n\"]; \n \n \n"];

WriteString[out,"WriteString[file,\"Implicit None \\n\"]; \n"];
WriteString[out,"MakeVariableList[Flatten[{couplings,masses}],\",Intent(in)\",file];\n"];
(* Switch[Length[NameObservables[[1,1]]], *)
Switch[Length[ExternalFields],
4, WriteString[out,"WriteString[file,\"Integer,Intent(in) :: gt1, gt2,gt3,gt4 \\n\"];\n"];,
3, WriteString[out,"WriteString[file,\"Integer,Intent(in) :: gt1, gt2,gt3 \\n\"];\n"];
        WriteString[out,"WriteString[file,\"Integer :: gt4 \\n\"];\n"];,
2, WriteString[out,"WriteString[file,\"Integer,Intent(in) :: gt1, gt2\\n\"];\n"];
        WriteString[out,"WriteString[file,\"Integer :: gt3, gt4\\n\"];\n"];,
1, WriteString[out,"WriteString[file,\"Integer,Intent(in) :: gt1 \\n\"];\n"];
        WriteString[out,"WriteString[file,\"Integer :: gt2, gt3, gt4\\n\"];\n"];
];
(* WriteString[out,"WriteString[file,\"Real(dp), Intent(out) :: ResultToReturn(:) \\n\\n\"];\n"]; *)
WriteString[out,"WriteString[file,\"Logical, Intent(in) :: OnlySM \\n\"];\n"];
WriteString[out,"WriteString[file,\"Integer :: iprop, i1, i2, i3, i4 \\n\"];\n"];
WriteString[out,"WriteString[file,\"Real(dp) :: MassEx1,MassEx2,MassEx3,MassEx4, MassEx12,MassEx22,MassEx32,MassEx42 \\n\"];\n"];

If[AddBoxes,
For[i=1,i<=Length[BoxOperators],
WriteString[out,"WriteString[file,\"Complex(dp), Intent(out) :: "<>ToString[BoxOperators[[i,1]]]<>" \\n\"]; \n"]; i++;];
];
If[AddScalars,
For[i=1,i<=Length[ScalarPenguinOperators],WriteString[out,"WriteString[file,\"Complex(dp), Intent(out) :: "<>ToString[ScalarPenguinOperators[[i,1]]]<>" \\n\"]; \n"];i++;];
];
If[AddVectors,
For[i=1,i<=Length[VectorPenguinOperators],WriteString[out,"WriteString[file,\"Complex(dp), Intent(out) :: "<>ToString[VectorPenguinOperators[[i,1]]]<>" \\n\"]; \n"];i++;];
];

If[AddScalarsTree,
For[i=1,i<=Length[ScalarTreeOperators],WriteString[out,"WriteString[file,\"Complex(dp), Intent(out) :: "<>ToString[ScalarTreeOperators[[i,1]]]<>" \\n\"]; \n"];i++;];
];
If[AddVectorsTree,
For[i=1,i<=Length[VectorTreeOperators],WriteString[out,"WriteString[file,\"Complex(dp), Intent(out) :: "<>ToString[VectorTreeOperators[[i,1]]]<>" \\n\"]; \n"];i++;];
];


WriteString[out,"WriteString[file,\"Complex(dp) :: vertex1L, vertex1R, vertex2L, vertex2R \\n\"];\n"];
WriteString[out,"WriteString[file,\"Real(dp) ::  MP, MP2, IMP2, IMP, MFin, MFin2, IMFin, IMFin2, Finite  \\n\"];\n"];
WriteString[out,"WriteString[file,\"Real(dp) ::  MS1, MS12, MS2, MS22, MF1, MF12, MF2, MF22, MV1, MV12, MV2, MV22  \\n\"];\n"];
WriteString[out,"WriteString[file,\"Complex(dp) ::  chargefactor  \\n\"];\n"];
WriteString[out,"WriteString[file,\"Complex(dp) ::  coup1L, coup1R, coup2L, coup2R, coup3L, coup3R, coup3, coup4L, coup4R \\n\\n\"];\n\n"];
WriteString[out,"WriteString[file,\"Complex(dp) ::  int1,int2,int3,int4,int5,int6,int7,int8 \\n\\n\"];\n\n"];

WriteString[out,"WriteString[file,\"Iname=Iname+1 \\n\"];\n"];
WriteString[out,"WriteString[file,\"NameOfUnit(Iname)='Calculate"<>NameProcess<>"' \\n\n\"];\n \n"];

WriteString[out,"AddCalcSquaredMasses[masses,file]; \n"];

WriteString[out,"(* Initaliziation *)\n"];
WriteString[out,"WriteString[file,\"Finite=1._dp \\n\"];\n"];
(* WriteString[out,"WriteString[file,\"ResultToReturn=0._dp \\n \\n\"];\n"]; *)

(* NECESSARY TO GENERALIZE THE FOLLOWING LINES! *)
For[i=1,i<=4,
WriteString[out,"WriteString[file,\"MassEx"<>ToString[i]<>"=\"<>SPhenoMass["<>ToString[ExternalFields[[i]]]<>",gt"<>ToString[i]<>"]<>\"  \\n\"];\n"];
WriteString[out,"WriteString[file,\"MassEx"<>ToString[i]<>"2=\"<>SPhenoMassSq["<>ToString[ExternalFields[[i]]]<>",gt"<>ToString[i]<>"]<>\" \\n\"];\n"];
i++;];

WriteString[out,"WriteString[file,\"! ------------------------------ \\n \"];\n"];
WriteString[out,"WriteString[file,\"! Amplitudes for external states \\n \"];\n"];
WriteString[out,"WriteString[file,\"! "<>ToString[ExternalFields]<>" \\n \"];\n"];
WriteString[out,"WriteString[file,\"! ------------------------------ \\n \\n\"];\n"];

WriteString[out,"WriteString[sphenoTeX,\"\\\\section{External states: $\"<>TeXOutput["<>ToString[{ExternalFields[[1]][{gt1}],ExternalFields[[2]][{gt2}],ExternalFields[[3]][{gt3}],ExternalFields[[4]][{gt4}]} /.Drop[ExternalFields,4]]<>"]<>\"$} \\n\"];\n"];

If[AddBoxes,
For[i=1,i<=Length[BoxOperators],WriteString[out,"WriteString[file,\""<>ToString[BoxOperators[[i,1]]]<>"=0._dp \\n\"]; \n"];i++;];
];
If[AddScalars,
For[i=1,i<=Length[ScalarPenguinOperators],WriteString[out,"WriteString[file,\""<>ToString[ScalarPenguinOperators[[i,1]]]<>"=0._dp \\n\"]; \n"];i++;];
];
If[AddVectors,
For[i=1,i<=Length[VectorPenguinOperators],WriteString[out,"WriteString[file,\""<>ToString[VectorPenguinOperators[[i,1]]]<>"=0._dp \\n\"]; \n"];i++;];
];
If[AddScalarsTree,
For[i=1,i<=Length[ScalarTreeOperators],WriteString[out,"WriteString[file,\""<>ToString[ScalarTreeOperators[[i,1]]]<>"=0._dp \\n\"]; \n"];i++;];
];
If[AddVectorsTree,
For[i=1,i<=Length[VectorTreeOperators],WriteString[out,"WriteString[file,\""<>ToString[VectorTreeOperators[[i,1]]]<>"=0._dp \\n\"]; \n"];i++;];
];

If[AddVectors,
WriteString[out,"WriteDiagramsObservable["<>NameProcess<>",{}, {}, {}, waveVector,  {}, penguinVector,  {}, file];\n"];
];
If[AddScalars,
WriteString[out,"WriteDiagramsObservable["<>NameProcess<>",{}, {}, waveScalar,  {}, penguinScalar, {},  {}, file];\n"];
];
If[AddVectorsTree,
WriteString[out,"WriteDiagramsObservable["<>NameProcess<>",{}, treeVector, {},  {}, {}, {}, {}, file];\n"];
];
If[AddScalarsTree,
WriteString[out,"WriteDiagramsObservable["<>NameProcess<>",treeScalar, {}, {},  {}, {}, {}, {}, file];\n"];
];
If[AddBoxes,
WriteString[out,"WriteDiagramsObservable["<>NameProcess<>",{}, {}, {}, {}, {}, {}, box, file];\n"];
];


If[AddBoxes,
For[i=1,i<=Length[BoxOperators],WriteString[out,"WriteString[file,\""<>ToString[BoxOperators[[i,1]]]<>"=oo16pi2*"<>ToString[BoxOperators[[i,1]]]<>" \\n\"]; \n"];i++;];
];
If[AddScalars,
For[i=1,i<=Length[ScalarPenguinOperators],WriteString[out,"WriteString[file,\""<>ToString[ScalarPenguinOperators[[i,1]]]<>"=oo16pi2*"<>ToString[ScalarPenguinOperators[[i,1]]]<>" \\n\"]; \n"];i++;];
];
If[AddVectors,
For[i=1,i<=Length[VectorPenguinOperators],WriteString[out,"WriteString[file,\""<>ToString[VectorPenguinOperators[[i,1]]]<>"=oo16pi2*"<>ToString[VectorPenguinOperators[[i,1]]]<>"\\n\"]; \n"];i++;];
];

WriteString[out,"WriteString[file,\"Iname=Iname-1\\n\\n\"]; \n"];
WriteString[out,"WriteString[file,\"End Subroutine Calculate"<>NameProcess<>" \\n\\n\"]; \n"];
WriteString[out,"]; \n"];
];



WriteWrapperCodeSARAH2F:=Block[{i,j,k},
(* We are going to generate two wrapper functions for SARAH *)
(* 1) Checks for all possible diagrams, extracts the necessary masses and couplings *)
(* 2) Writes the Fortran Code using the information from 1) as well as the calculated amplitudes *)

(* Note, works so far only with processes with four external fermions *)

WriteString[out,"(* Code automatically generated by 'PreSARAH' *) \n"];
WriteString[out,"(* Expressions for amplitudes are obtained by FeynArts/FormCalc *) \n"];
WriteString[out,"(* This file is supposed to be loaded and used by SARAH *) \n"];
Minutes=If[Date[][[5]]<10,"0"<>ToString[Date[][[5]]],ToString[Date[][[5]]]];
WriteString[out,"(* Created at "<>ToString[Date[][[4]]]<>":"<>Minutes<>" on "<>ToString[Date[][[3]]]<>"."<>ToString[Date[][[2]]]<>"."<>ToString[Date[][[1]]]<>" *) \n \n \n"];

WriteString[out,"Print[\"   ... \"," <>NameProcess<>"]; \n"];

WriteString[out,"NamesParticles =  "<>ToString[ExternalFields]<>"; \n "];

WriteString[out,"NamesOperators =  "<>ToString[Transpose[TriangleOperators][[1]]]<>"; \n "];

WriteString[out,"NameProcess = "<>NameProcess<>"; \n \n"];

(* WriteString[out,"NameObservables = "<>ToString[NameObservables]<>"; \n \n"]; *)

WriteString[out,"Generate["<>NameProcess<>"][file_]:=Block[{i,j,k}, \n \n"];

WriteString[out,"\n (* Creating all possible processes; extract information about involved masses/couplings *) \n"];


WriteString[out,"\n\n(* ------------------------------- *)\n"];
WriteString[out,"(* "<>ToString[ExternalFields]<>" *)\n"];
WriteString[out,"(* ------------------------------- *)\n \n"];
WriteString[out,"GetInformtion2Fermion1BosonProcess["<>ToString[ExternalFields[[1]]]<>","<>ToString[ExternalFields[[2]]]<>","<>ToString[ExternalFields[[3]]]<>","<>NameProcess<>",file]; \n"];


WriteString[out,"NeededMassesAll=Intersection[NeededMasses];\n"];
WriteString[out,"NeededCouplingsAll=Intersection[NeededCouplings];\n"];


WriteString[out,"WriteCodeObservablePreSARAH["<>NameProcess<>"][NeededMassesAll,NeededCouplingsAll,TreeContributions,WaveContributions,PenguinContributions,file]; \n"];

WriteString[out,"NeededMassAllSaved["<>NameProcess<>"] = masses \n"];

WriteString[out,"]; \n\n"];

WriteString[out,"WriteCodeObservablePreSARAH["<>NameProcess<>"][masses_,couplings_,tree_,wave_,penguin_,file_] :=Block[{i,j,k,fermions,scalars}, \n \n"];

WriteString[out,"NeededMassesAllSaved["<>NameProcess<>"] = masses; \n"];
WriteString[out,"NeededCouplingsAllSaved["<>NameProcess<>"] = couplings; \n"];
WriteString[out,"NeededCombinations["<>NameProcess<>"] = "<>ToString[CombinationGenerations]<>"; \n"];

WriteString[out,"Print[\"     writing SPheno code for \","<>NameProcess<>"]; \n"];

WriteString[out,"MakeSubroutineTitle[\"Calculate"<>NameProcess<>"\",Flatten[{masses,couplings}],"];

Switch[Length[ExternalFields],
1,WriteString[out,"{\"gt1\",\"OnlySM\"}, \n"];, 
2,WriteString[out,"{\"gt1\",\"gt2\",\"OnlySM\"}, \n"];, 
3,WriteString[out,"{\"gt1\",\"gt2\",\"gt3\",\"OnlySM\"}, \n"];,
4,WriteString[out,"{\"gt1\",\"gt2\",\"gt3\",\"gt4\",\"OnlySM\"}, \n"]; 
];

WriteString[out,ToString[Table["\""<>ToString[TriangleOperators[[i,1]]]<>"\"",{i,1,Length[TriangleOperators]}]]<>",file]; \n"]; 

WriteString[out,"WriteString[file,\"! ---------------------------------------------------------------- \\n\"]; \n"];
WriteString[out,"WriteString[file,\"! Code based on automatically generated SARAH extensions by 'PreSARAH' \\n\"]; \n"];
WriteString[out,"WriteString[file,\"! Expressions for amplitudes are obtained by FeynArts/FormCalc \\n\"]; \n"];
WriteString[out,"WriteString[file,\"! Based on user input for process "<>NameProcess<>" \\n\"]; \n"];
WriteString[out,"WriteString[file,\"! 'PreSARAH' output has been generated  at "<>ToString[Date[][[4]]]<>":"<>Minutes<>" on "<>ToString[Date[][[3]]]<>"."<>ToString[Date[][[2]]]<>"."<>ToString[Date[][[1]]]<>" \\n\"]; \n"];
WriteString[out,"WriteString[file,\"! ---------------------------------------------------------------- \\n \\n\"]; \n \n \n"];

WriteString[out,"WriteString[file,\"Implicit None \\n\"]; \n"];
WriteString[out,"MakeVariableList[Flatten[{couplings,masses}],\",Intent(in)\",file];\n"];
(* Switch[Length[NameObservables[[1,1]]], *)
Switch[Length[ExternalFields],
4, WriteString[out,"WriteString[file,\"Integer,Intent(in) :: gt1, gt2,gt3,gt4 \\n\"];\n"];,
3, WriteString[out,"WriteString[file,\"Integer,Intent(in) :: gt1, gt2,gt3 \\n\"];\n"];
        WriteString[out,"WriteString[file,\"Integer :: gt4 \\n\"];\n"];,
2, WriteString[out,"WriteString[file,\"Integer,Intent(in) :: gt1, gt2\\n\"];\n"];
        WriteString[out,"WriteString[file,\"Integer :: gt3, gt4\\n\"];\n"];,
1, WriteString[out,"WriteString[file,\"Integer,Intent(in) :: gt1 \\n\"];\n"];
        WriteString[out,"WriteString[file,\"Integer :: gt2, gt3, gt4\\n\"];\n"];
];
(* WriteString[out,"WriteString[file,\"Real(dp), Intent(out) :: ResultToReturn(:) \\n\\n\"];\n"]; *)
WriteString[out,"WriteString[file,\"Logical, Intent(in) :: OnlySM \\n\"];\n"];
WriteString[out,"WriteString[file,\"Integer :: iprop, i1, i2, i3, i4 \\n\"];\n"];
WriteString[out,"WriteString[file,\"Real(dp) :: MassEx1,MassEx2,MassEx3,MassEx12,MassEx22,MassEx32 \\n\"];\n"];

For[i=1,i<=Length[TriangleOperators],
WriteString[out,"WriteString[file,\"Complex(dp), Intent(out) :: "<>ToString[TriangleOperators[[i,1]]]<>" \\n\"]; \n"]; i++;];

WriteString[out,"WriteString[file,\"Real(dp) ::  MP, MP2, IMP2, IMP, MFin, MFin2, IMFin, IMFin2, Finite  \\n\"];\n"];
WriteString[out,"WriteString[file,\"Real(dp) ::  MS1, MS12, MS2, MS22, MF1, MF12, MF2, MF22, MV1, MV12, MV2, MV22  \\n\"];\n"];
WriteString[out,"WriteString[file,\"Complex(dp) ::  chargefactor  \\n\"];\n"];
WriteString[out,"WriteString[file,\"Complex(dp) ::  coup1L, coup1R, coup2L, coup2R, coup3L, coup3R, coup3, coup4L, coup4R \\n\\n\"];\n\n"];
WriteString[out,"WriteString[file,\"Complex(dp) ::  int1,int2,int3,int4,int5,int6,int7,int8 \\n\\n\"];\n\n"];

WriteString[out,"WriteString[file,\"Iname=Iname+1 \\n\"];\n"];
WriteString[out,"WriteString[file,\"NameOfUnit(Iname)='Calculate"<>NameProcess<>"' \\n\n\"];\n \n"];

WriteString[out,"AddCalcSquaredMasses[masses,file]; \n"];

WriteString[out,"(* Initaliziation *)\n"];
WriteString[out,"WriteString[file,\"Finite=1._dp \\n\"];\n"];
(* WriteString[out,"WriteString[file,\"ResultToReturn=0._dp \\n \\n\"];\n"]; *)

For[i=1,i<=3,
WriteString[out,"WriteString[file,\"MassEx"<>ToString[i]<>"=\"<>SPhenoMass["<>ToString[ExternalFields[[i]]]<>",gt"<>ToString[i]<>"]<>\"  \\n\"];\n"];
WriteString[out,"WriteString[file,\"MassEx"<>ToString[i]<>"2=\"<>SPhenoMassSq["<>ToString[ExternalFields[[i]]]<>",gt"<>ToString[i]<>"]<>\" \\n\"];\n"];
i++;];

WriteString[out,"WriteString[file,\"! ------------------------------ \\n \"];\n"];
WriteString[out,"WriteString[file,\"! Amplitudes for external states \\n \"];\n"];
WriteString[out,"WriteString[file,\"! "<>ToString[ExternalFields]<>" \\n \"];\n"];
WriteString[out,"WriteString[file,\"! ------------------------------ \\n \\n\"];\n"];

WriteString[out,"WriteString[sphenoTeX,\"\\\\section{External states: $\"<>TeXOutput["<>ToString[{ExternalFields[[1]][{gt1}],ExternalFields[[2]][{gt2}],ExternalFields[[3]][{gt3}]}]<>"]<>\"$} \\n\"];\n"];

For[i=1,i<=Length[TriangleOperators],WriteString[out,"WriteString[file,\""<>ToString[TriangleOperators[[i,1]]]<>"=0._dp \\n\"]; \n"];i++;];

WriteString[out,"WriteDiagramsObservable["<>NameProcess<>",tree, wave, penguin, file];\n"];

For[i=1,i<=Length[TriangleOperators],WriteString[out,"WriteString[file,\""<>ToString[TriangleOperators[[i,1]]]<>"=oo16pi2*"<>ToString[TriangleOperators[[i,1]]]<>" \\n\"]; \n"];i++;];

WriteString[out,"WriteString[file,\"Iname=Iname-1\\n\\n\"]; \n"];
WriteString[out,"WriteString[file,\"End Subroutine Calculate"<>NameProcess<>" \\n\\n\"]; \n"];
WriteString[out,"]; \n"];
];
